#include-once

#include "Utilities.au3"

Global $fBuild = 0, $fNewBuild = $fBuild
Global $nPieces = 1, $nMaxPieces
Global $fPlayBuild = True

Func DrawPiece( ByRef $aPiece, $nPieces )
	Local $n = 0

	glPushMatrix()
	glTranslatef( 0, 0, 0 )

	; 3 sides

  ; LEFT side
  glBegin( $GL_POLYGON )
	SideColor( $aPiece[$LEFT] )
  glVertex3f( -0.5,  0.45,  0.45 )
  glVertex3f( -0.5,  0.45, -0.45 )
  glVertex3f( -0.5, -0.45, -0.45 )
  glVertex3f( -0.5, -0.45,  0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; BACK side
  glBegin( $GL_POLYGON )
	SideColor( $aPiece[$BACK] )
  glVertex3f(  0.45, -0.45, -0.5 )
  glVertex3f( -0.45, -0.45, -0.5 )
  glVertex3f( -0.45,  0.45, -0.5 )
  glVertex3f(  0.45,  0.45, -0.5 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; BOTTOM side
  glBegin( $GL_POLYGON )
	SideColor( $aPiece[$BOTTOM] )
  glVertex3f(  0.45, -0.5,  0.45 )
  glVertex3f( -0.45, -0.5,  0.45 )
  glVertex3f( -0.45, -0.5, -0.45 )
  glVertex3f(  0.45, -0.5, -0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

	; Corner color
	glColor3ub( $aCornerColor[0], $aCornerColor[1], $aCornerColor[2] )

  ; 1 corner

  ; FRONT, LEFT, BOTTOM corner
  glBegin( $GL_TRIANGLES )
  glVertex3f( -0.45, -0.45, -0.5  )
  glVertex3f( -0.5,  -0.45, -0.45 )
  glVertex3f( -0.45, -0.5,  -0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; 3 corner sides

  ; LEFT, BOTTOM
  glBegin( $GL_POLYGON )
  glVertex3f( -0.5,  -0.45, -0.45 )
  glVertex3f( -0.5,  -0.45,  0.45 )
  glVertex3f( -0.45, -0.5,   0.45 )
  glVertex3f( -0.45, -0.5,  -0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; FRONT, BOTTOM
  glBegin( $GL_POLYGON )
  glVertex3f(  0.45, -0.45, -0.5  )
  glVertex3f(  0.45, -0.5,  -0.45 )
  glVertex3f( -0.45, -0.5,  -0.45 )
  glVertex3f( -0.45, -0.45, -0.5  )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; FRONT, LEFT
  glBegin( $GL_POLYGON )
  glVertex3f( -0.45, -0.45, -0.5  )
  glVertex3f( -0.5,  -0.45, -0.45 )
  glVertex3f( -0.5,   0.45, -0.45 )
  glVertex3f( -0.45,  0.45, -0.5  )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

	; 3 sides

  ; RIGHT side
  glBegin( $GL_POLYGON )
	SideColor( $aPiece[$RIGHT] )
  glVertex3f( 0.5,  0.45, -0.45 )
  glVertex3f( 0.5,  0.45,  0.45 )
  glVertex3f( 0.5, -0.45,  0.45 )
  glVertex3f( 0.5, -0.45, -0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; FRONT side
  glBegin( $GL_POLYGON )
	SideColor( $aPiece[$FRONT] )
  glVertex3f(  0.45,  0.45, 0.5 )
  glVertex3f( -0.45,  0.45, 0.5 )
  glVertex3f( -0.45, -0.45, 0.5 )
  glVertex3f(  0.45, -0.45, 0.5 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; TOP side
  glBegin( $GL_POLYGON )
	SideColor( $aPiece[$TOP] )
  glVertex3f(  0.45, 0.5, -0.45 )
  glVertex3f( -0.45, 0.5, -0.45 )
  glVertex3f( -0.45, 0.5,  0.45 )
  glVertex3f(  0.45, 0.5,  0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

	; Corner color
	glColor3ub( $aCornerColor[0], $aCornerColor[1], $aCornerColor[2] )

  ; 7 corners

  ; FRONT, RIGHT, BOTTOM
  glBegin( $GL_TRIANGLES )
  glVertex3f( 0.45, -0.45, -0.5  )
  glVertex3f( 0.5,  -0.45, -0.45 )
  glVertex3f( 0.45, -0.5,  -0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; FRONT, RIGHT, TOP
  glBegin( $GL_TRIANGLES )
  glVertex3f( 0.45, 0.45, -0.5  )
  glVertex3f( 0.5,  0.45, -0.45 )
  glVertex3f( 0.45, 0.5,  -0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; FRONT, LEFT, TOP
  glBegin( $GL_TRIANGLES )
  glVertex3f( -0.45, 0.45, -0.5  )
  glVertex3f( -0.5,  0.45, -0.45 )
  glVertex3f( -0.45, 0.5,  -0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; BACK, RIGHT, BOTTOM
  glBegin( $GL_TRIANGLES )
  glVertex3f( 0.45, -0.45, 0.5  )
  glVertex3f( 0.5,  -0.45, 0.45 )
  glVertex3f( 0.45, -0.5,  0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; BACK, RIGHT, TOP
  glBegin( $GL_TRIANGLES )
  glVertex3f( 0.45, 0.45, 0.5  )
  glVertex3f( 0.5,  0.45, 0.45 )
  glVertex3f( 0.45, 0.5,  0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; BACK, LEFT, TOP
  glBegin( $GL_TRIANGLES )
  glVertex3f( -0.45, 0.45, 0.5  )
  glVertex3f( -0.5,  0.45, 0.45 )
  glVertex3f( -0.45, 0.5,  0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; BACK, LEFT, BOTTOM
  glBegin( $GL_TRIANGLES )
  glVertex3f( -0.45, -0.45, 0.5  )
  glVertex3f( -0.5,  -0.45, 0.45 )
  glVertex3f( -0.45, -0.5,  0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; 9 corner sides

  ; FRONT, RIGHT
  glBegin( $GL_POLYGON )
  glVertex3f( 0.45, -0.45, -0.5  )
  glVertex3f( 0.5,  -0.45, -0.45 )
  glVertex3f( 0.5,   0.45, -0.45 )
  glVertex3f( 0.45,  0.45, -0.5  )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; FRONT, TOP
  glBegin( $GL_POLYGON )
  glVertex3f(  0.45, 0.45, -0.5  )
  glVertex3f(  0.45, 0.5,  -0.45 )
  glVertex3f( -0.45, 0.5,  -0.45 )
  glVertex3f( -0.45, 0.45, -0.5  )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; BACK, RIGHT
  glBegin( $GL_POLYGON )
  glVertex3f( 0.45, -0.45, 0.5  )
  glVertex3f( 0.5,  -0.45, 0.45 )
  glVertex3f( 0.5,   0.45, 0.45 )
  glVertex3f( 0.45,  0.45, 0.5  )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; BACK, TOP
  glBegin( $GL_POLYGON )
  glVertex3f(  0.45, 0.45, 0.5  )
  glVertex3f(  0.45, 0.5,  0.45 )
  glVertex3f( -0.45, 0.5,  0.45 )
  glVertex3f( -0.45, 0.45, 0.5  )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; BACK, LEFT
  glBegin( $GL_POLYGON )
  glVertex3f( -0.45, -0.45, 0.5  )
  glVertex3f( -0.5,  -0.45, 0.45 )
  glVertex3f( -0.5,   0.45, 0.45 )
  glVertex3f( -0.45,  0.45, 0.5  )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; BACK, BOTTOM
  glBegin( $GL_POLYGON )
  glVertex3f(  0.45, -0.45, 0.5  )
  glVertex3f(  0.45, -0.5,  0.45 )
  glVertex3f( -0.45, -0.5,  0.45 )
  glVertex3f( -0.45, -0.45, 0.5  )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; RIGHT, BOTTOM
  glBegin( $GL_POLYGON )
  glVertex3f( 0.5,  -0.45, -0.45 )
  glVertex3f( 0.5,  -0.45,  0.45 )
  glVertex3f( 0.45, -0.5,   0.45 )
  glVertex3f( 0.45, -0.5,  -0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; RIGHT, TOP
  glBegin( $GL_POLYGON )
  glVertex3f( 0.5,  0.45, -0.45 )
  glVertex3f( 0.5,  0.45,  0.45 )
  glVertex3f( 0.45, 0.5,   0.45 )
  glVertex3f( 0.45, 0.5,  -0.45 )
  glEnd()
	$n += 1
	If $n >= $nPieces Then
		glPopMatrix()
		Return
	EndIf

  ; LEFT, TOP
  glBegin( $GL_POLYGON )
  glVertex3f( -0.5,  0.45, -0.45 )
  glVertex3f( -0.5,  0.45,  0.45 )
  glVertex3f( -0.45, 0.5,   0.45 )
  glVertex3f( -0.45, 0.5,  -0.45 )
  glEnd()

	glPopMatrix()
EndFunc

; Draws the cube by drawing one piece at a time
; Remark that the drawing is done by executing a precompiled display list
Func DrawBuild( $iSize, $nPieces, $angle )
	Local $aPieceSides, $n = 1
	Local $d = PieceDisplacement( $iSize )
	Local $xSize = $iSize - 1, $xSpin = 0, $dx = $d
	Local $ySize = $iSize - 1, $ySpin = 0, $dy = $d
	Local $zSize = $iSize - 1, $zSpin = 0, $dz = $d
	Switch $fBuild
		Case $idXlayer
			$xSize = 0
			$xSpin = 1
			If $iSize > 1 Then _
				$dx = -0.5
		Case $idYlayer
			$ySize = 0
			$ySpin = 1
			If $iSize > 1 Then _
				$dy = -0.5
		Case $idZlayer
			$zSize = 0
			$zSpin = 1
			If $iSize > 1 Then _
				$dz = -0.5
	EndSwitch
	For $x = 0 To $xSize
		For $y = 0 To $ySize
			For $z = 0 To $zSize
				$aPieceSides = $aPieces[$x][$y][$z]
				If $aPieceSides[6] Then
					glPushMatrix()
						If $angle Then _
							glRotatef( $angle, $xSpin, $ySpin, $zSpin )
						glTranslatef( $dx+$x, $dy+$y, $dz+$z )
						glCallList( $aPieceSides[6] )
					glPopMatrix()
					If $n >= $nPieces Then Return
					$n += 1
				EndIf
			Next
		Next
	Next
EndFunc

; The DisplayBuild() function handles an entire OpenGL drawing cycle:
; Clears the window, saves the model view matrix, performs scaling and rotation, draws the cube, restores the matrix and swaps buffers.
; During this cycle there should not be any changes to the cube or the OpenGL matrices.
Func DisplayBuild( $iSize, $iAngX, $iAngY, $fBuild )
	Local Static $angle = 0, $n = 0
	Local $nMax, $fSpinLayer

	If $fBuild = $idCube And $iSize = 1 And $nPieces = 7 Then
		$nMax = 100
	Else
		$nMax = 10
	EndIf

	$n += 1
	If $fPlayBuild And $n >= $nMax Then
		$nPieces += 1
		$n = 0
	EndIf

	$fSpinLayer = False

	If $nPieces > $nMaxPieces + 5 Then
		If $fBuild = $idCube Then
			$angle += 1
		Else ; X,Y,Z layer
			$fSpinLayer = True
			$angle += 1
			;$angle += 2
		EndIf
	ElseIf $angle Then
		$angle = 0
	EndIf

	If $nPieces <= $nMaxPieces Then _
		UpdateProgressBar( $nPieces, $nMaxPieces )

	glClear( BitOR( $GL_COLOR_BUFFER_BIT, $GL_DEPTH_BUFFER_BIT ) )

	glPushMatrix()
		gluLookAt( 0,0,1+$dSphereDiameter/2, 0,0,0, 0,1,0 )
		glScalef( $dScale, $dScale, $dScale )
		glMultMatrixf( $mRotation )
		If $fBuild = $idCube Then
			If $angle = 0 Then
				glRotatef( $iAngX, 1, 0, 0 )
				glRotatef( $iAngY-90, 0, 1, 0 )
			Else
				glRotatef( $angle, 1, 1, 1 )
			EndIf
		Else
			glRotatef( $iAngX, 1, 0, 0 )
			glRotatef( $iAngY, 0, 1, 0 )
		EndIf
		If $fSpinLayer Then
			DrawBuild( $iSize, $nPieces, $angle )
		Else
			If $fBuild = $idCube And $iSize = 1 Then
				DrawPiece( $aPieces[0][0][0], $nPieces )
			Else
				DrawBuild( $iSize, $nPieces, 0 )
			EndIf
		EndIf
	glPopMatrix()

	SwapBuffers( $hDC )
EndFunc
