#include-once

#cs#####################
#   Create main menu   #
#ce#####################

Func CreateMainMenu()

	; --- Cubes menu ---

	Local $idCubes = GUICtrlCreateMenu( "Cubes" )
	$idPiece = GUICtrlCreateMenuItem( "Cube Piece", $idCubes )
	GUICtrlCreateMenuItem( "", $idCubes )
	$idPocket = GUICtrlCreateMenuItem( "Pocket Cube", $idCubes )
	$idRubik = GUICtrlCreateMenuItem( "Rubik's Cube", $idCubes )
	$idRevenge = GUICtrlCreateMenuItem( "Rubik's Revenge", $idCubes )
	$idProfessor = GUICtrlCreateMenuItem( "Professor's Cube", $idCubes )
	$idVcube6 = GUICtrlCreateMenuItem( "V-Cube 6", $idCubes )
	$idVcube7 = GUICtrlCreateMenuItem( "V-Cube 7", $idCubes )
	GUICtrlSetState( $idRubik, $GUI_CHECKED )

	GUICtrlSetOnEvent( $idPiece, "Piece" )
	GUICtrlSetOnEvent( $idPocket, "Pocket" )
	GUICtrlSetOnEvent( $idRubik, "Rubik" )
	GUICtrlSetOnEvent( $idRevenge, "Revenge" )
	GUICtrlSetOnEvent( $idProfessor, "Professor" )
	GUICtrlSetOnEvent( $idVcube6, "Vcube6" )
	GUICtrlSetOnEvent( $idVcube7, "Vcube7" )

	CreateCubesControls()

	; --- Scramble menu ---

	$idScramble = GUICtrlCreateMenuItem( "Scramble", -1 )

	GUICtrlSetOnEvent( $idScramble, "Scramble" )

	CreateScrambleControls()

	; --- Solve menu ---

	$idSolve = GUICtrlCreateMenuItem( "Solve", -1 )

	GUICtrlSetOnEvent( $idSolve, "Solve" )

	CreateSolveControls()

	; --- Build menu ---

	Local $idBuild = GUICtrlCreateMenu( "Build" )
	$idCube = GUICtrlCreateMenuItem( "Cube", $idBuild )
	GUICtrlCreateMenuItem( "", $idBuild )
	$idXlayer = GUICtrlCreateMenuItem( "X-Layer", $idBuild )
	$idYlayer = GUICtrlCreateMenuItem( "Y-Layer", $idBuild )
	$idZlayer = GUICtrlCreateMenuItem( "Z-Layer", $idBuild )

	GUICtrlSetOnEvent( $idCube, "Cube" )
	GUICtrlSetOnEvent( $idXlayer, "Xlayer" )
	GUICtrlSetOnEvent( $idYlayer, "Ylayer" )
	GUICtrlSetOnEvent( $idZlayer, "Zlayer" )

	CreateBuildControls()

	; --- Rotate menu ---

	Local $idRotate = GUICtrlCreateMenu( "Rotate" ), $tab = Chr(9)
	$idHome  = GUICtrlCreateMenuItem( "Home"  & $tab & "Home / H,h",    $idRotate )
	GUICtrlCreateMenuItem( "", $idRotate )
	$idLeft  = GUICtrlCreateMenuItem( "Left"  & $tab & "Left    / A,a", $idRotate )
	$idRight = GUICtrlCreateMenuItem( "Right" & $tab & "Right  / S,s",  $idRotate )
	$idUp    = GUICtrlCreateMenuItem( "Up"    & $tab & "Up      / W,w", $idRotate )
	$idDown  = GUICtrlCreateMenuItem( "Down"  & $tab & "Down / Z,z",    $idRotate )
	GUICtrlCreateMenuItem( "", $idRotate )
	Local $idSides = GUICtrlCreateMenu( "Cube sides", $idRotate )
	$id1 = GUICtrlCreateMenuItem( "Right"      & $tab & "Num 1 / 1", $idSides )
	$id2 = GUICtrlCreateMenuItem( "Left (x)"   & $tab & "Num 2 / 2", $idSides )
	$id3 = GUICtrlCreateMenuItem( "Top"        & $tab & "Num 3 / 3", $idSides )
	$id4 = GUICtrlCreateMenuItem( "Bottom (y)" & $tab & "Num 4 / 4", $idSides )
	$id5 = GUICtrlCreateMenuItem( "Front"      & $tab & "Num 5 / 5", $idSides )
	$id6 = GUICtrlCreateMenuItem( "Back (z)"   & $tab & "Num 6 / 6", $idSides )

	GUICtrlSetOnEvent( $idHome,  "RotateHome"  )
	GUICtrlSetOnEvent( $idLeft,  "RotateLeft"  )
	GUICtrlSetOnEvent( $idRight, "RotateRight" )
	GUICtrlSetOnEvent( $idUp,    "RotateUp"    )
	GUICtrlSetOnEvent( $idDown,  "RotateDown"  )

	GUICtrlSetOnEvent( $id1, "SideRight"  )
	GUICtrlSetOnEvent( $id2, "SideLeft"   )
	GUICtrlSetOnEvent( $id3, "SideTop"    )
	GUICtrlSetOnEvent( $id4, "SideBottom" )
	GUICtrlSetOnEvent( $id5, "SideFront"  )
	GUICtrlSetOnEvent( $id6, "SideBack"   )

	; --- Zoom menu ---

	Local $idZoom = GUICtrlCreateMenu( "Zoom" ), $tab = Chr(9)
	$idZoomIn  = GUICtrlCreateMenuItem( "Zoom In"  & $tab & "Page Up      / I,i", $idZoom )
	$idZoomOut = GUICtrlCreateMenuItem( "Zoom Out" & $tab & "Page Down / O,o", $idZoom )

	GUICtrlSetOnEvent( $idZoomIn,  "ZoomIn" )
	GUICtrlSetOnEvent( $idZoomOut, "ZoomOut" )

	; --- Logs menu ---

	Local $idLogs = GUICtrlCreateMenu( "Logs" )
	$idLogsLists  = GUICtrlCreateMenuItem( "Lists", $idLogs )
	$idLogsColors = GUICtrlCreateMenuItem( "Colors", $idLogs )

	GUICtrlSetOnEvent( $idLogsLists, "LogsLists" )
	GUICtrlSetOnEvent( $idLogsColors, "LogsColors" )

	; --- Options menu ---

	$idOptions = GUICtrlCreateMenuItem( "Options", -1 )

	GUICtrlSetOnEvent( $idOptions, "Options" )

	; --- Help menu ---

	$idHelp = GUICtrlCreateMenuItem( "Help", -1 )

	GUICtrlSetOnEvent( $idHelp, "Help" )
EndFunc


#cs###################
#   Menu functions   #
#ce###################

; Activating a menu will interrupt the main loop. To avoid that menu changes affecting OpenGL drawing functions are
; applied in the middle of an OpenGL drawing cycle, menu changes are handled in two steps. In the first step a flag
; is set to indicate that there is a menu change. In the second step the real menu change takes place. This step is
; performed in the main loop between two drawing cycles.

; Remark that it's menu changes affecting OpenGL drawing functions that only should be applied between two drawing
; cycles. Menu changes affecting the GUI can be applied immediately.

; For each of the menus there can be four sections:

#cs################
#   Menu header   #
#ce################

; Section 1 (the menu event functions declared above)

; --- Statusbar controls ---

; Section 2

; --- Control event functions ---

; Section 3

; --- Menu functions ---

; Section 4


#cs###############
#   Cubes menu   #
#ce###############

; $fCubesState and $iNewSize are the flags used to inform the main loop about a change in the Cubes menu

Func Piece()
	$iNewSize = 1																; $iNewSize is the flag used in the main loop to test if a new cube should be created
	If $iNewSize = $iSize Then $iNewSize = -1		; $iNewSize = -1 resets an existing cube, the size of the cube will not be changed
	UncheckCubesMenu( $iSize )									; Unchecking and checking menu items and updating the title can be done immediately
	GUICtrlSetState( $idPiece, $GUI_CHECKED )
	WinSetTitle( $hGui, "", "Cube Piece" )
	GUICtrlSetData( $cbName, "Piece" )
	ApplyCubesControls()												; Statusbar controls can be applied immediately
EndFunc

Func Pocket()
	$iNewSize = 2
	If $iNewSize = $iSize Then $iNewSize = -1
	UncheckCubesMenu( $iSize )
	GUICtrlSetState( $idPocket, $GUI_CHECKED )
	WinSetTitle( $hGui, "", "Pocket Cube" )
	GUICtrlSetData( $cbName, "Pocket" )
	ApplyCubesControls()
EndFunc

Func Rubik()
	$iNewSize = 3
	If $iNewSize = $iSize Then $iNewSize = -1
	UncheckCubesMenu( $iSize )
	GUICtrlSetState( $idRubik, $GUI_CHECKED )
	WinSetTitle( $hGui, "", "Rubik's Cube" )
	GUICtrlSetData( $cbName, "Rubik" )
	ApplyCubesControls()
EndFunc

Func Revenge()
	$iNewSize = 4
	If $iNewSize = $iSize Then $iNewSize = -1
	UncheckCubesMenu( $iSize )
	GUICtrlSetState( $idRevenge, $GUI_CHECKED )
	WinSetTitle( $hGui, "", "Rubik's Revenge" )
	GUICtrlSetData( $cbName, "Revenge" )
	ApplyCubesControls()
EndFunc

Func Professor()
	$iNewSize = 5
	If $iNewSize = $iSize Then $iNewSize = -1
	UncheckCubesMenu( $iSize )
	GUICtrlSetState( $idProfessor, $GUI_CHECKED )
	WinSetTitle( $hGui, "", "Professor's Cube" )
	GUICtrlSetData( $cbName, "Professor" )
	ApplyCubesControls()
EndFunc

Func Vcube6()
	$iNewSize = 6
	If $iNewSize = $iSize Then $iNewSize = -1
	UncheckCubesMenu( $iSize )
	GUICtrlSetState( $idVcube6, $GUI_CHECKED )
	WinSetTitle( $hGui, "", "V-Cube 6" )
	GUICtrlSetData( $cbName, "V-Cube 6" )
	ApplyCubesControls()
EndFunc

Func Vcube7()
	$iNewSize = 7
	If $iNewSize = $iSize Then $iNewSize = -1
	UncheckCubesMenu( $iSize )
	GUICtrlSetState( $idVcube7, $GUI_CHECKED )
	WinSetTitle( $hGui, "", "V-Cube 7" )
	GUICtrlSetData( $cbName, "V-Cube 7" )
	ApplyCubesControls()
EndFunc

Func UncheckCubesMenu( $iSize )
	Switch $iSize
		Case 1
			GUICtrlSetState( $idPiece, $GUI_UNCHECKED )
		Case 2
			GUICtrlSetState( $idPocket, $GUI_UNCHECKED )
		Case 3
			GUICtrlSetState( $idRubik, $GUI_UNCHECKED )
		Case 4
			GUICtrlSetState( $idRevenge, $GUI_UNCHECKED )
		Case 5
			GUICtrlSetState( $idProfessor, $GUI_UNCHECKED )
		Case 6
			GUICtrlSetState( $idVcube6, $GUI_UNCHECKED )
		Case 7
			GUICtrlSetState( $idVcube7, $GUI_UNCHECKED )
	EndSwitch
EndFunc

; --- Statusbar controls ---

Func CreateCubesControls()
	Local $label1, $label2, $label3

	; These controls are placed in the statusbar
	; Use a child window as a container for the controls
	$hCubes = GUICreate( "", 235, 24, 2, $iHeight + 3, $WS_CHILD, -1, $hGui )

	; Label to show the name of selected cube
	$cbName = GUICtrlCreateLabel( "Rubik", 2, 5, 50, 14 )

	; Vertical splitterbar
	$label1 = GUICtrlCreateLabel( "", 55, 2, 3, 20, $SS_ETCHEDFRAME )

	; Label to show the number of layer rotations
	$label2  = GUICtrlCreateLabel( "#", 62, 5, 10, 14, $SS_RIGHT )
	$label3  = GUICtrlCreateLabel( "",  74, 3, 24, 18, $SS_ETCHEDFRAME )
	$cbLabel = GUICtrlCreateLabel( "0", 76, 5, 20, 14 )
	GUICtrlSetBkColor( $cbLabel, 0xFFFFFF )

	; Buttons for the Cubes menu
	$cbUndo = GUICtrlCreateButton( "Undo", 103, 2, 40, 20 )
	$cbRedo = GUICtrlCreateButton( "Redo", 148, 2, 40, 20 )
	$cbNew  = GUICtrlCreateButton( "New",  193, 2, 40, 20 )
	GUICtrlSetState( $cbUndo, $GUI_DISABLE )
	GUICtrlSetState( $cbRedo, $GUI_DISABLE )

	GUICtrlSetOnEvent( $cbUndo, "CubeUndo" )
	GUICtrlSetOnEvent( $cbRedo, "CubeRedo" )
	GUICtrlSetOnEvent( $cbNew,  "CubeNew"  )

	GUISetState( @SW_HIDE )
	GUISwitch( $hGui )
EndFunc

Func ShowCubesControls( $fReset = True )
	$fCubesMenu = 1
	$fCubesState = 1

	If $fReset Then
		ResetUndosRedos()
		GUICtrlSetState( $cbUndo, $GUI_DISABLE )
		GUICtrlSetState( $cbRedo, $GUI_DISABLE )
	Else
		If $idxUndo Then
			GUICtrlSetState( $cbUndo, $GUI_ENABLE )
		Else
			GUICtrlSetState( $cbUndo, $GUI_DISABLE )
		EndIf
		If $idxRedo Then
			GUICtrlSetState( $cbRedo, $GUI_ENABLE )
		Else
			GUICtrlSetState( $cbRedo, $GUI_DISABLE )
		EndIf
	EndIf
	GUICtrlSetData( $cbLabel, $idxUndo )

	WinMove( $hCubes, "", 2, $iHeight + 3 )
	GUISetState( @SW_SHOW, $hCubes )

	If $fInitCubesStatusBarInfo Then _
		InitCubesStatusBarInfo()
EndFunc

Func HideCubesControls()
	GUISetState( @SW_HIDE, $hCubes )
	$fCubesState = 2
	$fCubesMenu = 0
EndFunc

Func ApplyCubesControls()
	If $fBuildMenu Then
		HideBuildControls()
	ElseIf $fScrambleMenu Then
		HideScrambleControls()
	ElseIf $fSolveMenu Then
		HideSolveControls()
	EndIf
	Local $i = $iNewSize
	If $i = -1 Then $i = $iSize
	$nScrambleStepsIni = $aScrambleStepsCubes[$i-1]
	$nScrambleStepsNew = $nScrambleStepsIni
	$nScrambleSteps = $nScrambleStepsNew
	If $fNewColors Then NewColors()
	ShowCubesControls()
EndFunc

; --- Control event functions ---

Func CubeUndo()
	If $fUndoRedoState <> 2 Then Return
	$fXYZlayer = $aUndoLog[$idxUndo-1][0]
	$nCubeLayer = $aUndoLog[$idxUndo-1][1]
	$fClockWise = Not $aUndoLog[$idxUndo-1][2]
	$nDegrees = $nDeltaDegrees
	$fTurnDone = 0
	$fTurn = True
	UpdateRedoLog()
	$idxUndo -= 1
	GUICtrlSetData( $cbLabel, $idxUndo )
	If $fLogsListsWin Then _
		_GUICtrlListView_DeleteItem( $hLVundo, $idxUndo )
	If $idxUndo = 0 Then _
		GUICtrlSetState( $cbUndo, $GUI_DISABLE )
	If $idxRedo = 1 Then _
		GUICtrlSetState( $cbRedo, $GUI_ENABLE )
	$fUndoRedoState = 0
EndFunc

Func CubeRedo()
	If $fUndoRedoState <> 2 Then Return
	$fXYZlayer = $aRedoLog[$idxRedo-1][0]
	$nCubeLayer = $aRedoLog[$idxRedo-1][1]
	$fClockWise = Not $aRedoLog[$idxRedo-1][2]
	$nDegrees = $nDeltaDegrees
	$fTurnDone = 0
	$fTurn = True
	UpdateUndoLog()
	$idxRedo -= 1
	GUICtrlSetData( $cbLabel, $idxUndo )
	If $fLogsListsWin Then _
		_GUICtrlListView_DeleteItem( $hLVredo, $idxRedo )
	If $idxUndo = 1 Then _
		GUICtrlSetState( $cbUndo, $GUI_ENABLE )
	If $idxRedo = 0 Then _
		GUICtrlSetState( $cbRedo, $GUI_DISABLE )
	$fUndoRedoState = 0
EndFunc

Func CubeNew()
	ResetUndosRedos()
	GUICtrlSetData( $cbLabel, $idxUndo )
	GUICtrlSetState( $cbUndo, $GUI_DISABLE )
	GUICtrlSetState( $cbRedo, $GUI_DISABLE )
	If $fNewColors Then NewColors()
	$iNewSize = -1
EndFunc

; --- Menu functions ---

Func UpdateUndoLog()
	If $idxUndo = $nUndo Then
		$nUndo += 1
		If Mod( $nUndo, 100 ) = 0 Then _
			ReDim $aUndoLog[$nUndo+100][3]
	EndIf
	$idxUndo += 1
	$aUndoLog[$idxUndo-1][0] = $fXYZlayer
	$aUndoLog[$idxUndo-1][1] = $nCubeLayer
	$aUndoLog[$idxUndo-1][2] = $fClockWise
	If $fLogsListsWin Then
		Local $i = $idxUndo - 1
		_GUICtrlListView_AddItem( $hLVundo, $i+1 )
		_GUICtrlListView_AddSubItem( $hLVundo, $i, $aXYZlayer[$aUndoLog[$i][0]], 1 )
		_GUICtrlListView_AddSubItem( $hLVundo, $i, $aUndoLog[$i][1], 2 )
		If $aUndoLog[$i][2] Then
			_GUICtrlListView_AddSubItem( $hLVundo, $i, "CW", 3 )
		Else
			_GUICtrlListView_AddSubItem( $hLVundo, $i, "CCW", 3 )
		EndIf
		_GUICtrlListView_EnsureVisible( $hLVundo, $i )
	EndIf
EndFunc

Func UpdateRedoLog()
	If $idxRedo = $nRedo Then
		$nRedo += 1
		If Mod( $nRedo, 100 ) = 0 Then _
			ReDim $aRedoLog[$nRedo+100][3]
	EndIf
	$idxRedo += 1
	$aRedoLog[$idxRedo-1][0] = $fXYZlayer
	$aRedoLog[$idxRedo-1][1] = $nCubeLayer
	$aRedoLog[$idxRedo-1][2] = $fClockWise
	If $fLogsListsWin Then
		Local $i = $idxRedo - 1
		_GUICtrlListView_AddItem( $hLVredo, $i+1 )
		_GUICtrlListView_AddSubItem( $hLVredo, $i, $aXYZlayer[$aRedoLog[$i][0]], 1 )
		_GUICtrlListView_AddSubItem( $hLVredo, $i, $aRedoLog[$i][1], 2 )
		If $aRedoLog[$i][2] Then
			_GUICtrlListView_AddSubItem( $hLVredo, $i, "CW", 3 )
		Else
			_GUICtrlListView_AddSubItem( $hLVredo, $i, "CCW", 3 )
		EndIf
		_GUICtrlListView_EnsureVisible( $hLVredo, $i )
	EndIf
EndFunc

Func ResetUndosRedos()
	$nUndo = 0
	$nRedo = 0
	$idxUndo = 0
	$idxRedo = 0
	If $fLogsListsWin Then
		_GUICtrlListView_BeginUpdate( $hLVundo )
		_GUICtrlListView_DeleteAllItems( $hLVundo )
		_GUICtrlListView_EndUpdate( $hLVundo )
		_GUICtrlListView_BeginUpdate( $hLVredo )
		_GUICtrlListView_DeleteAllItems( $hLVredo )
		_GUICtrlListView_EndUpdate( $hLVredo )
	EndIf
EndFunc

Func InitCubesStatusBarInfo()
	Local $size = $iNewSize
	If $iNewSize = -1 Then $size = $iSize
	$fInitCubesStatusBarInfo = False
	Switch $size
		Case 1
			GUICtrlSetData( $cbName, "Piece" )
		Case 2
			GUICtrlSetData( $cbName, "Pocket" )
		Case 3
			GUICtrlSetData( $cbName, "Rubik" )
		Case 4
			GUICtrlSetData( $cbName, "Revenge" )
		Case 5
			GUICtrlSetData( $cbName, "Professor" )
		Case 6
			GUICtrlSetData( $cbName, "V-Cube 6" )
		Case 7
			GUICtrlSetData( $cbName, "V-Cube 7" )
	EndSwitch
EndFunc


#cs##################
#   Scramble menu   #
#ce##################

; $fScrambleState is the flag used to inform the main loop about a change in the Scramble menu

; The Scramble menu is an on/off menu. You enters the Scramble mode by
; clicking once. And you leave the Scramble mode by clicking once more.

Func Scramble()
	If $fScrambleMenu = 0 Then
		If $fCubesMenu Then
			HideCubesControls()
		ElseIf $fBuildMenu Then
			HideBuildControls()
		ElseIf $fSolveMenu Then
			HideSolveControls()
		EndIf
		ShowScrambleControls()
	ElseIf $fScrambleMenu = 2 Then
		HideScrambleControls()
		ShowCubesControls( False )
	EndIf
EndFunc

; --- Statusbar controls ---

Func CreateScrambleControls()
	Local $label1, $label2, $label3

	; These controls are placed in the statusbar
	; Use a child window as a container for the controls
	$hScramble = GUICreate( "", 282, 24, 2, $iHeight + 3, $WS_CHILD, -1, $hGui )

	; Label to show the Scramble state
	$label1 = GUICtrlCreateLabel( "Scramble", 2, 5, 50, 14 )
	GUICtrlSetColor( $label1, 0xFF0000 )

	; Vertical splitterbar
	$label2 = GUICtrlCreateLabel( "", 55, 2, 3, 20, $SS_ETCHEDFRAME )

	; Input control for the Scramble menu
	$label3 = GUICtrlCreateLabel( "#", 62, 5, 10, 14, $SS_RIGHT )
	$srmInput = GUICtrlCreateInput( "100", 76, 4, 24, 16 )
	GUICtrlSetLimit( $srmInput, 3 )

	; Buttons for the Scramble menu
	$srmNew   = GUICtrlCreateButton( "New",   105, 2, 40, 20 )
	$srmNext  = GUICtrlCreateButton( "Next",  150, 2, 40, 20 )
	$srmPlay  = GUICtrlCreateButton( "Play",  195, 2, 40, 20 )
	$srmPause = GUICtrlCreateButton( "Pause", 240, 2, 40, 20 )

	GUICtrlSetOnEvent( $srmNew,   "srmNew"   )
	GUICtrlSetOnEvent( $srmNext,  "srmNext"  )
	GUICtrlSetOnEvent( $srmPlay,  "srmPlay"  )
	GUICtrlSetOnEvent( $srmPause, "srmPause" )

	GUISetState( @SW_HIDE )
	GUISwitch( $hGui )

	If $hProgress = 0 Then _
		CreateProgressBar()
EndFunc

Func ShowScrambleControls()
	$fScrambleMenu = 2
	$fScrambleState = 1

	If $fNewScrambleStepsValues Then
		$nScrambleStepsIni = $aScrambleStepsCubes[$iSize-1]
		$nScrambleStepsNew = $nScrambleStepsIni
		$nScrambleSteps = $nScrambleStepsNew
		$fNewScrambleStepsValues = False
	EndIf

	WinMove( $hScramble, "", 2, $iHeight + 3 )
	GUISetState( @SW_SHOW, $hScramble )
	GUICtrlSetData( $srmInput, $nScrambleStepsNew )
	GUICtrlSetData( $proLabel, $nScrambleStepsNew )
	WinMove( $hProgress, "", 294, $iHeight + 3 )
	GUISetState( @SW_SHOW, $hProgress )

	GUICtrlSetState( $srmNext, $GUI_DISABLE )
	GUICtrlSetState( $srmPlay, $GUI_DISABLE )

	ResetUndosRedos()
EndFunc

Func HideScrambleControls()
	GUISetState( @SW_HIDE, $hScramble )
	GUISetState( @SW_HIDE, $hProgress )
	$fScrambleState = 6
	$fScrambleMenu = 0
EndFunc

; --- Control event functions ---

Func srmInput()
	Local $s = GUICtrlRead( $srmInput )
	If $s <> "" Then
		If StringIsInt( $s ) And $s >= 1 And $s <= $nScrambleStepsIni Then
			GUICtrlSetColor( $srmInput, 0x000000 )
			$nScrambleStepsNew = Number( $s )
			srmNew()
		Else
			GUICtrlSetColor( $srmInput, 0xFF0000 )
		EndIf
	Else
		GUICtrlSetColor( $srmInput, 0x000000 )
		GUICtrlSetData( $srmInput, $nScrambleStepsNew )
		srmNew()
	EndIf
EndFunc

Func srmNew()
	$fScrambleState = 4
	$nScrambleSteps = $nScrambleStepsNew
	UpdateProgressBar( 0, $nScrambleSteps )
	GUICtrlSetData( $proLabel, $nScrambleStepsNew )
	GUICtrlSetData( $srmInput, $nScrambleStepsNew )
	GUICtrlSetColor( $srmInput, 0x000000 )

	GUICtrlSetState( $srmNext, $GUI_ENABLE )
	GUICtrlSetState( $srmPlay, $GUI_ENABLE )

	ResetUndosRedos()
EndFunc

Func srmNext()
	If $fScrambleState = 3 Then
		If $nScramble = 0 Then
			$nScrambleMax = 1
			$fScrambleState = 5
		ElseIf $nScrambleMax < $nScrambleSteps Then
			$nScrambleMax += 1
			$fScrambleState = 5
		EndIf
		If $nScrambleMax = $nScrambleSteps Then
			GUICtrlSetState( $srmNext, $GUI_DISABLE )
			GUICtrlSetState( $srmPlay, $GUI_DISABLE )
		EndIf
	EndIf
EndFunc

Func srmPlay()
	If $fScrambleState = 3 Then
		If $nScramble = 0 Then
			$fScrambleState = 1
		ElseIf $nScrambleMax < $nScrambleSteps Then
			$nScrambleMax = $nScrambleSteps
			$fScrambleState = 5
		EndIf
		GUICtrlSetState( $srmNext, $GUI_DISABLE )
		GUICtrlSetState( $srmPlay, $GUI_DISABLE )
	EndIf
EndFunc

Func srmPause()
	If $fScrambleState = 2 Then
		$nScrambleMax = $nScramble
		GUICtrlSetState( $srmNext, $GUI_ENABLE )
		GUICtrlSetState( $srmPlay, $GUI_ENABLE )
	EndIf
EndFunc

; --- Menu functions ---


#cs###############
#   Solve menu   #
#ce###############

; $fSolveState is the flag used to inform the main loop about a change in the Solve menu

; The Solve menu is an on/off menu. You enters the Solve mode by
; clicking once. And you leave the Solve mode by clicking once more.

Func Solve()
	If $fSolveMenu = 0 Then
		If $fCubesMenu Then
			HideCubesControls()
		ElseIf $fBuildMenu Then
			HideBuildControls()
		ElseIf $fScrambleMenu Then
			HideScrambleControls()
		EndIf
		ShowSolveControls()
	ElseIf $fSolveMenu = 3 Then
		HideSolveControls()
		ShowCubesControls( False )
	EndIf
EndFunc

; --- Statusbar controls ---

Func CreateSolveControls()
	Local $label1, $label2

	; These controls are placed in the statusbar
	; Use a child window as a container for the controls
	$hSolve = GUICreate( "", 270, 24, 2, $iHeight + 3, $WS_CHILD, -1, $hGui )

	; Label to show the Solve state
	$label1 = GUICtrlCreateLabel( "Solve", 2, 5, 30, 14 )
	GUICtrlSetColor( $label1, 0xFF0000 )

	; Vertical splitterbar
	$label2 = GUICtrlCreateLabel( "", 35, 2, 3, 20, $SS_ETCHEDFRAME )

	; Buttons for the Build menu
	$slvUndo     = GUICtrlCreateButton( "Undo",   48, 2, 40, 20 )
	$slvUndoNext = GUICtrlCreateButton( "Next",   93, 2, 40, 20 )
	$slvRedo     = GUICtrlCreateButton( "Redo",  138, 2, 40, 20 )
	$slvRedoNext = GUICtrlCreateButton( "Next",  183, 2, 40, 20 )
	$slvPause    = GUICtrlCreateButton( "Pause", 228, 2, 40, 20 )

	GUICtrlSetOnEvent( $slvUndo,     "slvUndo"     )
	GUICtrlSetOnEvent( $slvUndoNext, "slvUndoNext" )
	GUICtrlSetOnEvent( $slvRedo,     "slvRedo"     )
	GUICtrlSetOnEvent( $slvRedoNext, "slvRedoNext" )
	GUICtrlSetOnEvent( $slvPause,    "slvPause"    )

	GUISetState( @SW_HIDE )
	GUISwitch( $hGui )

	If $hProgress = 0 Then _
		CreateProgressBar()
EndFunc

Func ShowSolveControls()
	$fSolveMenu = 3
	$fSolveState = 1

	$fSolve = 1
	$idxUndoLimit = 0
	$idxUndoMax = $idxUndo + $idxRedo
	$idxRedoMax = $idxUndo + $idxRedo
	If $idxUndoMax Then
		UpdateProgressBar( $idxUndoMax - $idxUndo, $idxUndoMax )
		GUICtrlSetData( $proLabel, $idxUndoMax )
		$slvButtons = True
	Else
		GUICtrlSetData( $proLabel, 1 )
		UpdateProgressBar( 0, 1 )
	EndIf

	GUICtrlSetState( $slvUndo,     $GUI_DISABLE )
	GUICtrlSetState( $slvUndoNext, $GUI_DISABLE )
	GUICtrlSetState( $slvRedo,     $GUI_DISABLE )
	GUICtrlSetState( $slvRedoNext, $GUI_DISABLE )

	WinMove( $hSolve, "", 2, $iHeight + 3 )
	GUISetState( @SW_SHOW, $hSolve )
	WinMove( $hProgress, "", 282, $iHeight + 3 )
	GUISetState( @SW_SHOW, $hProgress )
EndFunc

Func HideSolveControls()
	GUISetState( @SW_HIDE, $hSolve )
	GUISetState( @SW_HIDE, $hProgress )
	$fSolveState = 5
	$fSolveMenu = 0
EndFunc

; --- Control event functions ---

Func slvUndo()
	$fSolve = 1
	$idxUndoLimit = 0
	If $idxUndo = $idxUndoMax Then
		$fSolveState = 1
	ElseIf $idxUndo Then
		$fSolveState = 4
	EndIf
	GUICtrlSetState( $slvUndo,     $GUI_DISABLE )
	GUICtrlSetState( $slvUndoNext, $GUI_DISABLE )
	GUICtrlSetState( $slvRedo,     $GUI_DISABLE )
	GUICtrlSetState( $slvRedoNext, $GUI_DISABLE )
	$slvButtons = True
EndFunc

Func slvUndoNext()
	$fSolve = 1
	If $idxUndo = $idxUndoMax Then
		$fSolveState = 1
		$idxUndoLimit = $idxUndoMax - 1
		GUICtrlSetState( $slvRedo, $GUI_ENABLE )
		GUICtrlSetState( $slvRedoNext, $GUI_ENABLE )
	ElseIf $idxUndo Then
		$fSolveState = 4
		$idxUndoLimit = $idxUndo - 1
		If $idxUndoLimit = 0 Then _
			$slvButtons = True
	EndIf
EndFunc

Func slvRedo()
	$fSolve = 2
	$fSolveState = 1
	$idxRedoLimit = 0
	GUICtrlSetState( $slvUndo,     $GUI_DISABLE )
	GUICtrlSetState( $slvUndoNext, $GUI_DISABLE )
	GUICtrlSetState( $slvRedo,     $GUI_DISABLE )
	GUICtrlSetState( $slvRedoNext, $GUI_DISABLE )
	$slvButtons = True
EndFunc

Func slvRedoNext()
	$fSolve = 2
	If $idxRedo = $idxRedoMax Then
		$fSolveState = 1
		$idxRedoLimit = $idxRedoMax - 1
		GUICtrlSetState( $slvUndo, $GUI_ENABLE )
		GUICtrlSetState( $slvUndoNext, $GUI_ENABLE )
	ElseIf $idxRedo Then
		$fSolveState = 4
		$idxRedoLimit = $idxRedo - 1
		If $idxRedoLimit = 0 Then _
			$slvButtons = True
	EndIf
EndFunc

Func slvPause()
	$fSolve = 2
	If $fSolveState = 2 Then
		If $fSolve = 1 Then
			$idxUndoLimit = $idxUndo
		ElseIf $fSolve = 2 Then
			$idxRedoLimit = $idxRedo
		EndIf
	EndIf
EndFunc

; --- Menu functions ---

Func slvButtons()
	If $idxUndo Then
		GUICtrlSetState( $slvUndo, $GUI_ENABLE )
		GUICtrlSetState( $slvUndoNext, $GUI_ENABLE )
	Else
		GUICtrlSetState( $slvUndo, $GUI_DISABLE )
		GUICtrlSetState( $slvUndoNext, $GUI_DISABLE )
	EndIf
	If $idxRedo Then
		GUICtrlSetState( $slvRedo, $GUI_ENABLE )
		GUICtrlSetState( $slvRedoNext, $GUI_ENABLE )
	Else
		GUICtrlSetState( $slvRedo, $GUI_DISABLE )
		GUICtrlSetState( $slvRedoNext, $GUI_DISABLE )
	EndIf
EndFunc


#cs###############
#   Build menu   #
#ce###############

; $fBuildState and $fNewBuild are the flags used to inform the main loop about a change in the Build menu

Func Cube()
	If $fBuild = $idCube Then
		HideBuildControls()
		ShowCubesControls()
	Else
		$fNewBuild = $idCube
		If $fBuild Then UncheckBuildMenu( $fBuild )
		GUICtrlSetState( $idCube, $GUI_CHECKED )
		If $fBuild = 0 Then ApplyBuildControls()
	EndIf
EndFunc

Func Xlayer()
	If $fBuild = $idXlayer Then
		HideBuildControls()
		ShowCubesControls()
	Else
		$fNewBuild = $idXlayer
		If $fBuild Then UncheckBuildMenu( $fBuild )
		GUICtrlSetState( $idXlayer, $GUI_CHECKED )
		If $fBuild = 0 Then ApplyBuildControls()
	EndIf
EndFunc

Func Ylayer()
	If $fBuild = $idYlayer Then
		HideBuildControls()
		ShowCubesControls()
	Else
		$fNewBuild = $idYlayer
		If $fBuild Then UncheckBuildMenu( $fBuild )
		GUICtrlSetState( $idYlayer, $GUI_CHECKED )
		If $fBuild = 0 Then ApplyBuildControls()
	EndIf
EndFunc

Func Zlayer()
	If $fBuild = $idZlayer Then
		HideBuildControls()
		ShowCubesControls()
	Else
		$fNewBuild = $idZlayer
		If $fBuild Then UncheckBuildMenu( $fBuild )
		GUICtrlSetState( $idZlayer, $GUI_CHECKED )
		If $fBuild = 0 Then ApplyBuildControls()
	EndIf
EndFunc

Func UncheckBuildMenu( $fBuild )
	Switch $fBuild
		Case $idCube, $idXlayer, $idYlayer, $idZlayer
			GUICtrlSetState( $fBuild, $GUI_UNCHECKED )
	EndSwitch
EndFunc

; --- Statusbar controls ---

Func CreateBuildControls()
	Local $label1, $label2

	; These controls are placed in the statusbar
	; Use a child window as a container for the controls
	$hBuild = GUICreate( "", 270, 24, 2, $iHeight + 3, $WS_CHILD, -1, $hGui )

	; Label to show the Build state
	$label1 = GUICtrlCreateLabel( "Build", 2, 5, 30, 14 )
	GUICtrlSetColor( $label1, 0xFF0000 )

	; Vertical splitterbar
	$label2 = GUICtrlCreateLabel( "", 35, 2, 3, 20, $SS_ETCHEDFRAME )

	; Buttons for the Build menu
	$bldFirst = GUICtrlCreateButton( "First",  48, 2, 40, 20 )
	$bldPrev  = GUICtrlCreateButton( "Prev",   93, 2, 40, 20 )
	$bldNext  = GUICtrlCreateButton( "Next",  138, 2, 40, 20 )
	$bldLast  = GUICtrlCreateButton( "Last",  183, 2, 40, 20 )
	$bldPlay  = GUICtrlCreateButton( "Play",  228, 2, 40, 20 )

	GUICtrlSetOnEvent( $bldFirst, "FirstPiece" )
	GUICtrlSetOnEvent( $bldPrev,  "PrevPiece"  )
	GUICtrlSetOnEvent( $bldNext,  "NextPiece"  )
	GUICtrlSetOnEvent( $bldLast,  "LastPiece"  )
	GUICtrlSetOnEvent( $bldPlay,  "PlayBuild"  )

	GUISetState( @SW_HIDE )
	GUISwitch( $hGui )

	If $hProgress = 0 Then _
		CreateProgressBar()
EndFunc

Func ShowBuildControls()
	$fBuildMenu = 4
	$fBuildState = 1
	WinMove( $hBuild, "", 2, $iHeight + 3 )
	GUISetState( @SW_SHOW, $hBuild )
	WinMove( $hProgress, "", 282, $iHeight + 3 )
	GUISetState( @SW_SHOW, $hProgress )
	ResetUndosRedos()
EndFunc

Func HideBuildControls()
	UncheckBuildMenu( $fBuild )
	GUISetState( @SW_HIDE, $hBuild )
	GUISetState( @SW_HIDE, $hProgress )
	$fBuildState = 2
	$fBuildMenu = 0
EndFunc

Func ApplyBuildControls()
	If $fCubesMenu Then
		HideCubesControls()
	ElseIf $fScrambleMenu Then
		HideScrambleControls()
	ElseIf $fSolveMenu Then
		HideSolveControls()
	EndIf
	ShowBuildControls()
EndFunc

; --- Control event functions ---

Func FirstPiece()
	$fPlayBuild = False
	$nPieces = 1
EndFunc

Func PrevPiece()
	$fPlayBuild = False
	If $nPieces > $nMaxPieces Then $nPieces = $nMaxPieces
	If $nPieces > 1 Then $nPieces -= 1
EndFunc

Func NextPiece()
	$fPlayBuild = False
	If $nPieces > $nMaxPieces Then $nPieces = $nMaxPieces - 1
	If $nPieces < $nMaxPieces Then $nPieces += 1
EndFunc

Func LastPiece()
	$fPlayBuild = False
	$nPieces = $nMaxPieces
EndFunc

Func PlayBuild()
	$fPlayBuild = True
EndFunc

; --- Menu functions ---

Func CalcMaxPieces()
	If $fBuild = $idCube Then
		If $iSize = 1 Then
			$nMaxPieces = 26
		Else
			$nMaxPieces = $iSize^3 - ($iSize-2)^3
		EndIf
	Else
		$nMaxPieces = $iSize^2
	EndIf
	GUICtrlSetData( $proLabel, $nMaxPieces )
EndFunc


#cs################
#   Rotate menu   #
#ce################

Func RotateHome()
	$fRotate = 6
	$iNewAngleX = 30
	$iNewAngleY = 45
EndFunc

Func RotateLeft()
	$fRotate = 2
	$iNewAngleY = $iAngleY - 90
EndFunc

Func RotateRight()
	$fRotate = 3
	$iNewAngleY = $iAngleY + 90
EndFunc

Func RotateUp()
	$fRotate = 4
	$iNewAngleX = $iAngleX - 60
EndFunc

Func RotateDown()
	$fRotate = 5
	$iNewAngleX = $iAngleX + 60
EndFunc

Func SideRight()
	$fRotate = 7
	$iNewAngleX = 0
	$iNewAngleY = -90
	$mRotation = $IDENTITY_MATRIX
	If $fMenuState = $fCubesMenu Then _
		GUICtrlSetData( $cbName, "Right" )
	$fSetHomePos = False
EndFunc

Func SideLeft()
	$fRotate = 7
	$iNewAngleX = 0
	$iNewAngleY = 90
	$mRotation = $IDENTITY_MATRIX
	If $fMenuState = $fCubesMenu Then _
		GUICtrlSetData( $cbName, "Left" )
	$fSetHomePos = False
EndFunc

Func SideTop()
	$fRotate = 7
	$iNewAngleX = 90
	$iNewAngleY = 0
	$mRotation = $IDENTITY_MATRIX
	If $fMenuState = $fCubesMenu Then _
		GUICtrlSetData( $cbName, "Top" )
	$fSetHomePos = False
EndFunc

Func SideBottom()
	$fRotate = 7
	$iNewAngleX = -90
	$iNewAngleY = 0
	$mRotation = $IDENTITY_MATRIX
	If $fMenuState = $fCubesMenu Then _
		GUICtrlSetData( $cbName, "Bottom" )
	$fSetHomePos = False
EndFunc

Func SideFront()
	$fRotate = 7
	$iNewAngleX = 0
	$iNewAngleY = 0
	$mRotation = $IDENTITY_MATRIX
	If $fMenuState = $fCubesMenu Then _
		GUICtrlSetData( $cbName, "Front" )
	$fSetHomePos = False
EndFunc

Func SideBack()
	$fRotate = 7
	$iNewAngleX = 0
	$iNewAngleY = 180
	$mRotation = $IDENTITY_MATRIX
	If $fMenuState = $fCubesMenu Then _
		GUICtrlSetData( $cbName, "Back" )
	$fSetHomePos = False
EndFunc

; --- Statusbar controls ---

; --- Control event functions ---

; --- Menu functions ---


#cs##############
#   Zoom menu   #
#ce##############

Func ZoomIn()
	$dNewScale = $dScale * 1.1
	If $dNewScale * $iSize > $dSphereDiameter / 2 Then _
		$dNewScale = ( $dSphereDiameter / 2 ) / $iSize
	$fZoom = 1
EndFunc

Func ZoomOut()
	$dNewScale = $dScale * 0.9
	If $dNewScale < 1.0 Then _
		$dNewScale = 1.0
	$fZoom = 1
EndFunc

; --- Statusbar controls ---

; --- Control event functions ---

; --- Menu functions ---


#cs##############
#   Logs menu   #
#ce##############

Func LogsLists()
	If $fLogsListsWin Then
		HideLogsListsWin()
	Else
		LogsListsWin()
	EndIf
EndFunc

Func LogsColors()
	If $fLogsColorsWin Then
		HideLogsColorsWin()
	Else
		LogsColorsWin()
	EndIf
EndFunc

; --- Statusbar controls ---

; --- Control event functions ---

; --- Menu functions ---


#cs#################
#   Options menu   #
#ce#################

Func Options()
	OptionsWin()
EndFunc

; --- Statusbar controls ---

; --- Control event functions ---

; --- Menu functions ---


#cs##############
#   Help menu   #
#ce##############

Func Help()
	HelpWin()
EndFunc

; --- Statusbar controls ---

; --- Control event functions ---

; --- Menu functions ---


#cs################
#   ProgressBar   #
#ce################

Func CreateProgressBar()
	Local $label1, $label2

	; These controls are placed in the statusbar
	; Use a child window as a container for the controls
	$hProgress = GUICreate( "", 282, 24, 248, $iHeight + 3, $WS_CHILD, -1, $hGui )

	; Vertical splitterbar
	$label1 = GUICtrlCreateLabel( "", 3, 2, 3, 20, $SS_ETCHEDFRAME )

	; Minimum value
	$label2 = GUICtrlCreateLabel( "1", 12, 5, 10, 14, $SS_RIGHT )

	; Progressbar
	$idProgress = GUICtrlCreateProgress( 24, 2, 230, 20 )

	; Maximum value
	$proLabel = GUICtrlCreateLabel( "100", 256, 5, 24, 14, $SS_LEFT )

	GUISetState( @SW_HIDE )
	GUISwitch( $hGui )
EndFunc

Func UpdateProgressBar( $n, $max )
	Local $pct = $n / $max * 100
	GUICtrlSetData( $idProgress, $pct )
EndFunc
