#include-once

#include <Misc.au3>
#include <WinAPI.au3>
#include <GuiListView.au3>
#include <GuiRichEdit.au3>
#include <GDIPlus.au3>


#cs######################
#   Logs lists window   #
#ce######################

Global $hLogsListsWin = 0, $fLogsListsWin = False
Global $hLVundo, $idLVundo, $idLVredo, $hLVredo
Global $aXYZlayer[4] = [ "", "X", "Y", "Z" ]

Func LogsListsWin()
	If $hLogsListsWin Then
		GUISetState( @SW_SHOWNOACTIVATE, $hLogsListsWin )
	Else
		Local $iWidth = 440, $iHeigth = 444, $aPos = WinGetPos( $hGui )
		Local $x = $aPos[0]+($aPos[2]-$iWidth)/2, $y = $aPos[1]+($aPos[3]-$iHeigth)/2
		$hLogsListsWin = GUICreate( "Cube Lists", $iWidth, $iHeigth, $x, $y, $DS_MODALFRAME + $WS_SYSMENU )
		GUISetOnEvent( $GUI_EVENT_CLOSE, "HideLogsListsWin", $hLogsListsWin )
		GUISetIcon( "res\RubiksCube.ico" )
		LogsListsWinControls()
		GUISetState()
	EndIf
	UpdateUndoLV()
	UpdateRedoLV()
	$fLogsListsWin = True
	GUICtrlSetState( $idLogsLists, $GUI_CHECKED )
EndFunc

Func CloseLogsListsWin()
	GUIDelete( $hLogsListsWin )
	$fLogsListsWin = False
EndFunc

Func HideLogsListsWin()
	GUICtrlSetState( $idLogsLists, $GUI_UNCHECKED )
	GUISetState( @SW_HIDE, $hLogsListsWin )
	$fLogsListsWin = False
EndFunc

Func LogsListsWinControls()
	GUICtrlCreateLabel( "Undo log", 10, 10, 201, 16 )
	$idLVundo = GUICtrlCreateListView( "", 10, 26, 201, 374 )
	$hLVundo = ControlGetHandle( $hLogsListsWin, "", $idLVundo )
	_GUICtrlListView_AddColumn( $hLVundo, "#", 30, 2 )
	_GUICtrlListView_AddColumn( $hLVundo, "XYZ", 45, 2 )
	_GUICtrlListView_AddColumn( $hLVundo, "Layer", 45, 2 )
	_GUICtrlListView_AddColumn( $hLVundo, "Direction", 60, 2 )

	GUICtrlCreateLabel( "Redo log", 221, 10, 201, 16 )
	$idLVredo = GUICtrlCreateListView( "", 221, 26, 201, 374 )
	$hLVredo = ControlGetHandle( $hLogsListsWin, "", $idLVredo )
	_GUICtrlListView_AddColumn( $hLVredo, "#", 30, 2 )
	_GUICtrlListView_AddColumn( $hLVredo, "XYZ", 45, 2 )
	_GUICtrlListView_AddColumn( $hLVredo, "Layer", 45, 2 )
	_GUICtrlListView_AddColumn( $hLVredo, "Direction", 60, 2 )
EndFunc

Func UpdateUndoLV()
	_GUICtrlListView_BeginUpdate( $hLVundo )
	_GUICtrlListView_DeleteAllItems( $hLVundo )
	For $i = 0 To $idxUndo - 1
		_GUICtrlListView_AddItem( $hLVundo, $i+1 )
		_GUICtrlListView_AddSubItem( $hLVundo, $i, $aXYZlayer[$aUndoLog[$i][0]], 1 )
		_GUICtrlListView_AddSubItem( $hLVundo, $i, $aUndoLog[$i][1], 2 )
		If $aUndoLog[$i][2] Then
			_GUICtrlListView_AddSubItem( $hLVundo, $i, "CW", 3 )
		Else
			_GUICtrlListView_AddSubItem( $hLVundo, $i, "CCW", 3 )
		EndIf
	Next
	If $idxUndo Then _ 
		_GUICtrlListView_EnsureVisible( $hLVundo, $idxUndo - 1 )
	_GUICtrlListView_EndUpdate( $hLVundo )
EndFunc

Func UpdateRedoLV()
	_GUICtrlListView_BeginUpdate( $hLVredo )
	_GUICtrlListView_DeleteAllItems( $hLVredo )
	For $i = 0 To $idxRedo - 1
		_GUICtrlListView_AddItem( $hLVredo, $i+1 )
		_GUICtrlListView_AddSubItem( $hLVredo, $i, $aXYZlayer[$aRedoLog[$i][0]], 1 )
		_GUICtrlListView_AddSubItem( $hLVredo, $i, $aRedoLog[$i][1], 2 )
		If $aRedoLog[$i][2] Then
			_GUICtrlListView_AddSubItem( $hLVredo, $i, "CW", 3 )
		Else
			_GUICtrlListView_AddSubItem( $hLVredo, $i, "CCW", 3 )
		EndIf
	Next
	If $idxRedo Then _ 
		_GUICtrlListView_EnsureVisible( $hLVredo, $idxRedo - 1 )
	_GUICtrlListView_EndUpdate( $hLVredo )
EndFunc


#cs#######################
#   Logs colors window   #
#ce#######################

Global $hLogsColorsWin = 0, $fLogsColorsWin = False, $hGraphics, $aBrushes[6]

Func LogsColorsWin()
	If $hLogsColorsWin Then
		GUISetState( @SW_SHOW, $hLogsColorsWin )
	Else
		Local $iWidth = 450, $iHeigth = 400, $aPos = WinGetPos( $hGui )
		Local $x = $aPos[0]+($aPos[2]-$iWidth)/2, $y = $aPos[1]+($aPos[3]-$iHeigth)/2
		$hLogsColorsWin = GUICreate( "Cube Colors", $iWidth, $iHeigth, $x, $y, $DS_MODALFRAME + $WS_SYSMENU )
		GUISetOnEvent( $GUI_EVENT_CLOSE, "HideLogsColorsWin", $hLogsColorsWin )
		GUIRegisterMsg( $WM_ACTIVATE, "WM_ACTIVATE" )
		GUISetIcon( "res\RubiksCube.ico" )
		GUISetState( @SW_SHOW )
		_GDIPlus_Startup()
		$hGraphics = _GDIPlus_GraphicsCreateFromHWND( $hLogsColorsWin )
		For $i = 0 To 5
			$aBrushes[$i] = _GDIPlus_BrushCreateSolid( 0xFF000000 + $aColors[$i] )
		Next
	EndIf
	GUICtrlSetState( $idLogsColors, $GUI_CHECKED )
	LogsColorsWinControls()
	$fLogsColorsWin = True
EndFunc

Func CloseLogsColorsWin()
	For $i = 0 To 5
		_GDIPlus_BrushDispose( $aBrushes[$i] )
	Next
	_GDIPlus_GraphicsDispose( $hGraphics )
	_GDIPlus_Shutdown()
	GUIRegisterMsg( $WM_ACTIVATE, "" )
	GUIDelete( $hLogsColorsWin )
	$fLogsColorsWin = False
EndFunc

Func HideLogsColorsWin()
	GUICtrlSetState( $idLogsColors, $GUI_UNCHECKED )
	GUISetState( @SW_HIDE, $hLogsColorsWin )
	$fLogsColorsWin = False
EndFunc

Func RefreshLogsColorsWin()
	LogsColorsUpdateAll()
EndFunc

Func LogsColorsWinControls()
	_GDIPlus_GraphicsDrawRect( $hGraphics, 116,  26, 105, 105 ) ; Top
	_GDIPlus_GraphicsDrawRect( $hGraphics,  10, 132, 105, 105 ) ; Left
	_GDIPlus_GraphicsDrawRect( $hGraphics, 116, 132, 105, 105 ) ; Front
	_GDIPlus_GraphicsDrawRect( $hGraphics, 222, 132, 105, 105 ) ; Right
	_GDIPlus_GraphicsDrawRect( $hGraphics, 328, 132, 105, 105 ) ; Back
	_GDIPlus_GraphicsDrawRect( $hGraphics, 116, 238, 105, 105 ) ; Bottom
	_GDIPlus_GraphicsDrawString( $hGraphics, "Top (3)", 147, 8, "Tahoma" )
	_GDIPlus_GraphicsDrawString( $hGraphics, "Left (2)", 43, 114, "Tahoma" )
	_GDIPlus_GraphicsDrawString( $hGraphics, "Right (1)", 251, 114, "Tahoma" )
	_GDIPlus_GraphicsDrawString( $hGraphics, "Back (6)", 358, 114, "Tahoma" )
	_GDIPlus_GraphicsDrawString( $hGraphics, "Bottom (4)", 141, 345, "Tahoma" )
	_GDIPlus_GraphicsDrawLine( $hGraphics, 116-30, 132+105+30, 116-5, 132+105+5 )
	_GDIPlus_GraphicsDrawString( $hGraphics, "Front (5)", 35, 132+105+30, "Tahoma" )
	LogsColorsUpdateAll()
EndFunc

Func LogsColorsUpdateAll()
	If $iSize > 1 Then
		LogsColorsSquares( 116,  26, $iSize )
		LogsColorsSquares(  10, 132, $iSize )
		LogsColorsSquares( 116, 132, $iSize )
		LogsColorsSquares( 222, 132, $iSize )
		LogsColorsSquares( 328, 132, $iSize )
		LogsColorsSquares( 116, 238, $iSize )
	EndIf
	LogsColorsFillSquaresYside( $TOP,    $iSize )
	LogsColorsFillSquaresXside( $LEFT,   $iSize )
	LogsColorsFillSquaresZside( $FRONT,  $iSize )
	LogsColorsFillSquaresXside( $RIGHT,  $iSize )
	LogsColorsFillSquaresZside( $BACK,   $iSize )
	LogsColorsFillSquaresYside( $BOTTOM, $iSize )
EndFunc

Func LogsColorsSquares( $x, $y, $iSize )
	If $iSize = 1 Then Return
	Local $w = 104 - ( $iSize - 1 ), $m = Mod( $w, $iSize )
	$w -= $m
	$w /= $iSize
	If $m Then $w += 1
	Local $j = 1, $w2 = $w
	For $i = 1 To $iSize - 1
		_GDIPlus_GraphicsDrawLine( $hGraphics, $x + 0,        $y + $w2 + $j, $x + 104,      $y + $w2 + $j )
		_GDIPlus_GraphicsDrawLine( $hGraphics, $x + $w2 + $j, $y + 0,        $x + $w2 + $j, $y + 104      )
		If $m Then
			$m -= 1
			If $m = 0 Then $w -= 1
		EndIf
		$w2 += $w
		$j += 1
	Next
EndFunc

; If $zLayer = -1 all the $iSize*$iSize squares of the side is painted
; If $zLayer <> -1 only the $iSize squares in the layer of the side is painted
Func LogsColorsFillSquaresXside( $side, $iSize, $zLayer = -1 )
	Local $x, $z1, $z2, $xx, $yy = 132, $aPiece
	If $side = $RIGHT Then
		$x = $iSize - 1
		$xx = 222
	Else
		$x = 0
		$xx = 10
	EndIf
	Local $w = 104 - ( $iSize - 1 )
	Local $m = Mod( $w, $iSize )
	$w -= $m
	$w /= $iSize
	If $m Then $w += 1
	Local $jz = 1, $wz = $w, $wz2 = 0, $mz = $m, $i
	If $zLayer = -1 Then
		$z1 = 0
		$z2 = $iSize - 1
	Else
		$z1 = $zLayer
		$z2 = $zLayer
		If $side = $RIGHT Then
			For $z = $iSize - 2 To $z1 Step -1
				AdjustSquare( $mz, $wz, $wz2, $jz )
			Next
		Else
			For $z = 0 To $z1 - 1
				AdjustSquare( $mz, $wz, $wz2, $jz )
			Next
		EndIf
	EndIf
	For $z = $z1 To $z2
		Local $jy = 1, $wy = $w, $wy2 = 0, $my = $m
		If $side = $RIGHT And $zLayer = -1 Then
			$i = $iSize - 1 - $z
		Else
			$i = $z
		EndIf
		For $y = 0 To $iSize - 1
			$aPiece = $aPieces[$x][$iSize-1-$y][$i]
			_GDIPlus_GraphicsFillRect( $hGraphics, $xx+$wz2+$jz, $yy+$wy2+$jy, $wz, $wy, $aBrushes[$aPiece[$side]] )
			AdjustSquare( $my, $wy, $wy2, $jy )
		Next
		If $zLayer = -1 Then _
			AdjustSquare( $mz, $wz, $wz2, $jz )
	Next
EndFunc

; Only the $iSize squares in the layer of the side is painted
; (Same as above but this is for the layers perpendicular to the layers above)
Func LogsColorsFillSquaresXside2( $side, $iSize, $yLayer )
	Local $x, $xx, $yy = 132, $aPiece
	If $side = $RIGHT Then
		$x = $iSize - 1
		$xx = 222
	Else
		$x = 0
		$xx = 10
	EndIf
	Local $w = 104 - ( $iSize - 1 )
	Local $m = Mod( $w, $iSize )
	$w -= $m
	$w /= $iSize
	If $m Then $w += 1
	Local $jy = 1, $wy = $w, $wy2 = 0, $my = $m
	For $y = $iSize - 2 To $yLayer Step -1
		AdjustSquare( $my, $wy, $wy2, $jy )
	Next
	Local $jz = 1, $wz = $w, $wz2 = 0, $mz = $m, $i
	For $z = 0 To $iSize - 1
		If $side = $RIGHT Then
			$i = $iSize - 1 - $z
		Else
			$i = $z
		EndIf
		$aPiece = $aPieces[$x][$yLayer][$i]
		_GDIPlus_GraphicsFillRect( $hGraphics, $xx+$wz2+$jz, $yy+$wy2+$jy, $wz, $wy, $aBrushes[$aPiece[$side]] )
		AdjustSquare( $mz, $wz, $wz2, $jz )
	Next
EndFunc

; If $xLayer = -1 all the $iSize*$iSize squares of the side is painted
; If $xLayer <> -1 only the $iSize squares in the layer of the side is painted
Func LogsColorsFillSquaresYside( $side, $iSize, $xLayer = -1 )
	Local $y, $x1, $x2, $xx = 116, $yy, $aPiece
	If $side = $TOP Then
		$y = $iSize - 1
		$yy = 26
	Else
		$y = 0
		$yy = 238
	EndIf
	Local $w = 104 - ( $iSize - 1 )
	Local $m = Mod( $w, $iSize )
	$w -= $m
	$w /= $iSize
	If $m Then $w += 1
	Local $jx = 1, $wx = $w, $wx2 = 0, $mx = $m, $i
	If $xLayer = -1 Then
		$x1 = 0
		$x2 = $iSize - 1
	Else
		$x1 = $xLayer
		$x2 = $xLayer
		For $x = 0 To $x1 - 1
			AdjustSquare( $mx, $wx, $wx2, $jx )
		Next
	EndIf
	For $x = $x1 To $x2
		Local $jz = 1, $wz = $w, $wz2 = 0, $mz = $m
		For $z = 0 To $iSize - 1
			If $side = $TOP Then
				$i = $z
			Else
				$i = $iSize - 1 - $z
			EndIf
			$aPiece = $aPieces[$x][$y][$i]
			_GDIPlus_GraphicsFillRect( $hGraphics, $xx+$wx2+$jx, $yy+$wz2+$jz, $wx, $wz, $aBrushes[$aPiece[$side]] )
			AdjustSquare( $mz, $wz, $wz2, $jz )
		Next
		If $xLayer = -1 Then _
			AdjustSquare( $mx, $wx, $wx2, $jx )
	Next
EndFunc

; Only the $iSize squares in the layer of the side is painted
; (Same as above but this is for the layers perpendicular to the layers above)
Func LogsColorsFillSquaresYside2( $side, $iSize, $zLayer )
	Local $y, $xx = 116, $yy, $aPiece
	Local $w = 104 - ( $iSize - 1 )
	Local $m = Mod( $w, $iSize )
	$w -= $m
	$w /= $iSize
	If $m Then $w += 1
	Local $jz = 1, $wz = $w, $wz2 = 0, $mz = $m
	If $side = $TOP Then
		For $z = 0 To $zLayer - 1
			AdjustSquare( $mz, $wz, $wz2, $jz )
		Next
		$y = $iSize - 1
		$yy = 26
	Else
		For $z = $iSize - 2 To $zLayer Step -1
			AdjustSquare( $mz, $wz, $wz2, $jz )
		Next
		$yy = 238
		$y = 0
	EndIf
	Local $jx = 1, $wx = $w, $wx2 = 0, $mx = $m
	For $x = 0 To $iSize - 1
		$aPiece = $aPieces[$x][$y][$zLayer]
		_GDIPlus_GraphicsFillRect( $hGraphics, $xx+$wx2+$jx, $yy+$wz2+$jz, $wx, $wz, $aBrushes[$aPiece[$side]] )
		AdjustSquare( $mx, $wx, $wx2, $jx )
	Next
EndFunc

; If $xLayer = -1 all the $iSize*$iSize squares of the side is painted
; If $xLayer <> -1 only the $iSize squares in the layer of the side is painted
Func LogsColorsFillSquaresZside( $side, $iSize, $xLayer = -1 )
	Local $z, $x1, $x2, $xx, $yy = 132, $aPiece
	If $side = $FRONT Then
		$z = $iSize - 1
		$xx = 116
	Else
		$z = 0
		$xx = 328
	EndIf
	Local $w = 104 - ( $iSize - 1 )
	Local $m = Mod( $w, $iSize )
	$w -= $m
	$w /= $iSize
	If $m Then $w += 1
	Local $jx = 1, $wx = $w, $wx2 = 0, $mx = $m, $i
	If $xLayer = -1 Then
		$x1 = 0
		$x2 = $iSize - 1
	Else
		$x1 = $xLayer
		$x2 = $xLayer
		If $side = $FRONT Then
			For $x = 0 To $x1 - 1
				AdjustSquare( $mx, $wx, $wx2, $jx )
			Next
		Else
			For $x = $iSize - 2 To $x1 Step -1
				AdjustSquare( $mx, $wx, $wx2, $jx )
			Next
		EndIf
	EndIf
	For $x = $x1 To $x2
		Local $jy = 1, $wy = $w, $wy2 = 0, $my = $m
		If $side = $BACK And $xLayer = -1 Then
			$i = $iSize - 1 - $x
		Else
			$i = $x
		EndIf
		For $y = 0 To $iSize - 1
			$aPiece = $aPieces[$i][$iSize-1-$y][$z]
			_GDIPlus_GraphicsFillRect( $hGraphics, $xx+$wx2+$jx, $yy+$wy2+$jy, $wx, $wy, $aBrushes[$aPiece[$side]] )
			AdjustSquare( $my, $wy, $wy2, $jy )
		Next
		If $xLayer = -1 Then _
			AdjustSquare( $mx, $wx, $wx2, $jx )
	Next
EndFunc

; Only the $iSize squares in the layer of the side is painted
; (Same as above but this is for the layers perpendicular to the layers above)
Func LogsColorsFillSquaresZside2( $side, $iSize, $yLayer )
	Local $z, $xx, $yy = 132, $aPiece
	If $side = $FRONT Then
		$z = $iSize - 1
		$xx = 116
	Else
		$z = 0
		$xx = 328
	EndIf
	Local $w = 104 - ( $iSize - 1 )
	Local $m = Mod( $w, $iSize )
	$w -= $m
	$w /= $iSize
	If $m Then $w += 1
	Local $jy = 1, $wy = $w, $wy2 = 0, $my = $m
	For $y = $iSize - 2 To $yLayer Step -1
		AdjustSquare( $my, $wy, $wy2, $jy )
	Next
	Local $jx = 1, $wx = $w, $wx2 = 0, $mx = $m, $i
	For $x = 0 To $iSize - 1
		If $side = $BACK Then
			$i = $iSize - 1 - $x
		Else
			$i = $x
		EndIf
		$aPiece = $aPieces[$i][$yLayer][$z]
		_GDIPlus_GraphicsFillRect( $hGraphics, $xx+$wx2+$jx, $yy+$wy2+$jy, $wx, $wy, $aBrushes[$aPiece[$side]] )
		AdjustSquare( $mx, $wx, $wx2, $jx )
	Next
EndFunc

Func AdjustSquare( ByRef $m, ByRef $w, ByRef $w2, ByRef $j )
	If $m Then
		$m -= 1
		If $m = 0 Then
			$w -= 1
			$j += 1
		EndIf
	EndIf
	$w2 += $w
	$j += 1
EndFunc

Func WM_ACTIVATE( $hWnd, $Msg, $wParam, $lParam )
	Switch $hWnd
		Case $hLogsColorsWin
			If $fLogsColorsWin And $wParam Then _
				LogsColorsWinControls()
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc


#cs###################
#   Options window   #
#ce###################

Global $hOptionsWin = 0, $idOptionsTab
Global $hGeneralWin, $hColorsWin, $hLastWin

; General window
Global $idMouseButtons1, $idMouseButtons2
Global $idRotateLayerSlow, $idRotateLayerMedium, $idRotateLayerFast
Global $idSimulateLayerRotations
Global $idScrambleStepsCube2, $idScrambleStepsCube3, $idScrambleStepsCube4, $idScrambleStepsCube5, $idScrambleStepsCube6, $idScrambleStepsCube7
Global $DefaultGeneral, $UndoGeneral, $SaveGeneral
Global $fNewValues = 0

Global $fSwapMouseButtons = False
Global $fSwapMouseButtonsIni = $fSwapMouseButtons
Global $fSwapMouseButtonsNew = $fSwapMouseButtonsIni
;$fSwapMouseButtons = $fSwapMouseButtonsNew

Global $nDeltaDegrees = 3
Global $nDeltaDegreesIni = $nDeltaDegrees
Global $nDeltaDegreesNew = $nDeltaDegreesIni
;$nDeltaDegrees = $nDeltaDegreesNew

Global $fSimulateLayerRotations = True
Global $fSimulateLayerRotationsIni = $fSimulateLayerRotations
Global $fSimulateLayerRotationsNew = $fSimulateLayerRotationsIni
;$fSimulateLayerRotations = $fSimulateLayerRotationsNew

Global $fNewScrambleStepsValues = False
Global $aDefScrambleStepsCubes[7] = [ 1, 25, 25, 50, 50, 100, 100 ]
Global $aIniScrambleStepsCubes = $aDefScrambleStepsCubes
Global $aNewScrambleStepsCubes = $aIniScrambleStepsCubes
Global $aScrambleStepsCubes = $aNewScrambleStepsCubes
Global $aScrambleStepsAccelKeys[1][2]
Global $ScrambleStepsCubeEnter

; Colors window
Global $RightColor, $LeftColor, $TopColor, $BottomColor, $FrontColor, $BackColor, $CornerColor, $BackGrColor
Global $DefaultColors, $UndoColors, $SaveColors

Global $aDefColors[8] = [ _				; $aDefColors is used to set the default colors
	16^4*$aRIGHTcolor[0]  + 16^2*$aRIGHTcolor[1]  + $aRIGHTcolor[2], _
	16^4*$aLEFTcolor[0]   + 16^2*$aLEFTcolor[1]   + $aLEFTcolor[2], _
	16^4*$aTOPcolor[0]    + 16^2*$aTOPcolor[1]    + $aTOPcolor[2], _
	16^4*$aBOTTOMcolor[0] + 16^2*$aBOTTOMcolor[1] + $aBOTTOMcolor[2], _
	16^4*$aFRONTcolor[0]  + 16^2*$aFRONTcolor[1]  + $aFRONTcolor[2], _
	16^4*$aBACKcolor[0]   + 16^2*$aBACKcolor[1]   + $aBACKcolor[2], _
	16^4*$aCornerColor[0] + 16^2*$aCornerColor[1] + $aCornerColor[2], _
	16^4*$aBackGround[0]  + 16^2*$aBackGround[1]  + $aBackGround[2] ]

Global $aIniColors = $aDefColors	; $aIniColors is used to check if $aColors must be saved in inifile when program terminates
Global $aNewColors = $aIniColors	; $aNewColors is used to save new colors entered in the Options
Global $aColors = $aNewColors			; $aColors is the array with the current colors
Global $fNewColors = False

Func OptionsWin()
	If $hOptionsWin Then
		GUISetState( @SW_SHOW, $hOptionsWin )
	Else
		Local $iWidth = 528, $iHeigth = 572, $aPos = WinGetPos( $hGui )
		Local $x = $aPos[0]+($aPos[2]-$iWidth)/2, $y = $aPos[1]+($aPos[3]-$iHeigth)/2
		$hOptionsWin = GUICreate( "Cube Options", $iWidth, $iHeigth, $x, $y, $DS_MODALFRAME + $WS_SYSMENU )
		GUISetOnEvent( $GUI_EVENT_CLOSE, "HideOptionsWin", $hOptionsWin )
		GuiRegisterMsg( $WM_NCACTIVATE, "WM_NCACTIVATE" )
		GUISetIcon( "res\RubiksCube.ico" )
		OptionsWinControls()
		GUISetState()
	EndIf
EndFunc

Func CloseOptionsWin()
	GUIDelete( $hOptionsWin )
EndFunc

Func HideOptionsWin()
	GUISetState( @SW_HIDE, $hOptionsWin )
EndFunc

Func WM_NCACTIVATE( $hWnd, $iMsg, $iwParam )
	If $hWnd = $hOptionsWin And Not $iwParam Then Return 1
EndFunc

Func OptionsWinControls()
	Local $iStyle = BitXOR( $GUI_SS_DEFAULT_GUI, $WS_CAPTION )

	$idOptionsTab = GUICtrlCreateTab( 5, 5, 512, 532 )
	GUICtrlCreateTabItem( "General" )
	GUICtrlSetState( -1, $GUI_SHOW )
	GUICtrlCreateTabItem( "Colors" )
	GUICtrlCreateTabItem("")

	GUICtrlSetOnEvent( $idOptionsTab, "OptionsTab" )

	; General
	$hGeneralWin = GUICreate( "", 500, 500, 10, 30, $iStyle )
	GUISetBkColor( 0xFFFFFF, $hGeneralWin )
	_WinAPI_SetParent( $hGeneralWin, $hOptionsWin )
	CreateGeneralWinControls()
	GUISetState( @SW_SHOW )
	GUISwitch( $hOptionsWin )
	$hLastWin = $hGeneralWin

	; Colors
	$hColorsWin = GUICreate( "", 500, 500, 10, 30, $iStyle )
	GUISetBkColor( 0xFFFFFF, $hColorsWin )
	_WinAPI_SetParent( $hColorsWin, $hOptionsWin )
	CreateColorsWinControls()
	GUISetState( @SW_HIDE )
	GUISwitch( $hOptionsWin )
EndFunc

Func OptionsTab()
	Switch GUICtrlRead( $idOptionsTab )
		Case 0
			GUISetState( @SW_HIDE, $hLastWin )
			GUISetState( @SW_SHOW, $hGeneralWin )
			$hLastWin = $hGeneralWin
		Case 1
			GUISetState( @SW_HIDE, $hLastWin )
			GUISetState( @SW_SHOW, $hColorsWin )
			$hLastWin = $hColorsWin
	EndSwitch
EndFunc

; --- General ---

Func CreateGeneralWinControls()
	GUICtrlCreateGroup( "Mouse buttons", 10, 10, 480, 80 )
	$idMouseButtons1 = GUICtrlCreateRadio( "Left button to turn a layer, right button to rotate the cube", 20, 30, 400, 20 )
	$idMouseButtons2 = GUICtrlCreateRadio( "Right button to turn a layer, left button to rotate the cube", 20, 60, 400, 20 )
	GUICtrlSetOnEvent( $idMouseButtons1, "MouseButtons" )
	GUICtrlSetOnEvent( $idMouseButtons2, "MouseButtons" )
	GUICtrlCreateGroup( "", -99, -99, 1, 1 )
	UpdateMouseButtons()

	GUICtrlCreateGroup( "Rotation speed when turning a layer with the mouse", 10, 110, 480, 50 )
	$idRotateLayerSlow   = GUICtrlCreateRadio( "Slow",    20, 130, 80, 20 )
	$idRotateLayerMedium = GUICtrlCreateRadio( "Medium", 120, 130, 80, 20 )
	$idRotateLayerFast   = GUICtrlCreateRadio( "Fast",   220, 130, 80, 20 )
	GUICtrlSetOnEvent( $idRotateLayerSlow,   "RotateLayerSpeed" )
	GUICtrlSetOnEvent( $idRotateLayerMedium, "RotateLayerSpeed" )
	GUICtrlSetOnEvent( $idRotateLayerFast,   "RotateLayerSpeed" )
	GUICtrlCreateGroup( "", -99, -99, 1, 1 )
	UpdateRotateLayerSpeed()

	GUICtrlCreateGroup( "Scramble / Solve", 10, 180, 480, 50 )
	$idSimulateLayerRotations = GUICtrlCreateCheckbox( "Simulate layer rotations", 20, 200, 400, 20 )
	If $fSimulateLayerRotations Then GUICtrlSetState( $idSimulateLayerRotations, $GUI_CHECKED )
	GUICtrlSetOnEvent( $idSimulateLayerRotations, "SimulateLayerRotations" )
	GUICtrlCreateGroup( "", -99, -99, 1, 1 )

	GUICtrlCreateGroup( "Scramble steps (max 200)", 10, 250, 480, 150 )
	Local $s = "(Changes are applied when the Scramble menu is selected)"
	GUICtrlCreateLabel( $s, 170, 270, 300, 16 )
								GUICtrlCreateLabel( "Pocket Cube:",       20, 270, 100, 16 )
	$idScrambleStepsCube2 = GUICtrlCreateInput( "25",      120, 270,  24, 16, $SS_RIGHT )
	GUICtrlSetData( $idScrambleStepsCube2, $aScrambleStepsCubes[1] )
	GUICtrlSetLimit( $idScrambleStepsCube2, 3 )
								GUICtrlCreateLabel( "Rubik's Cube:",      20, 290, 100, 16 )
	$idScrambleStepsCube3 = GUICtrlCreateInput( "25",      120, 290,  24, 16, $SS_RIGHT )
	GUICtrlSetData( $idScrambleStepsCube3, $aScrambleStepsCubes[2] )
	GUICtrlSetLimit( $idScrambleStepsCube3, 3 )
								GUICtrlCreateLabel( "Rubik's Revenge:",   20, 310, 100, 16 )
	$idScrambleStepsCube4 = GUICtrlCreateInput( "50",      120, 310,  24, 16, $SS_RIGHT )
	GUICtrlSetData( $idScrambleStepsCube4, $aScrambleStepsCubes[3] )
	GUICtrlSetLimit( $idScrambleStepsCube4, 3 )
								GUICtrlCreateLabel( "Professor's Cube:",  20, 330, 100, 16 )
	$idScrambleStepsCube5 = GUICtrlCreateInput( "50",      120, 330,  24, 16, $SS_RIGHT )
	GUICtrlSetData( $idScrambleStepsCube5, $aScrambleStepsCubes[4] )
	GUICtrlSetLimit( $idScrambleStepsCube5, 3 )
								GUICtrlCreateLabel( "V-Cube 6:",          20, 350, 100, 16 )
	$idScrambleStepsCube6 = GUICtrlCreateInput( "100",     120, 350,  24, 16, $SS_RIGHT )
	GUICtrlSetData( $idScrambleStepsCube6, $aScrambleStepsCubes[5] )
	GUICtrlSetLimit( $idScrambleStepsCube6, 3 )
								GUICtrlCreateLabel( "V-Cube 7:",          20, 370, 100, 16 )
	$idScrambleStepsCube7 = GUICtrlCreateInput( "100",     120, 370,  24, 16, $SS_RIGHT )
	GUICtrlSetData( $idScrambleStepsCube7, $aScrambleStepsCubes[6] )
	GUICtrlSetLimit( $idScrambleStepsCube7, 3 )
	GUICtrlCreateGroup( "", -99, -99, 1, 1 )

	$ScrambleStepsCubeEnter = GUICtrlCreateDummy()
	$aScrambleStepsAccelKeys[0][0] = "{ENTER}"
	$aScrambleStepsAccelKeys[0][1] = $ScrambleStepsCubeEnter
	GUISetAccelerators( $aScrambleStepsAccelKeys, $hGeneralWin )
	GUICtrlSetOnEvent( $ScrambleStepsCubeEnter, "ScrambleStepsCube" )

	$DefaultGeneral = GUICtrlCreateButton( "Defaults", 60, 420, 130, 30 )
	GUICtrlSetOnEvent( $DefaultGeneral, "DefaultGeneral" )
	CheckDefValues()

	$UndoGeneral = GUICtrlCreateButton( "Undo", 210, 420, 130, 30 )
	GUICtrlSetOnEvent( $UndoGeneral, "UndoGeneral" )
	GUICtrlSetState( $UndoGeneral, $GUI_DISABLE )

	$SaveGeneral = GUICtrlCreateButton( "Save", 360, 420, 130, 30 )
	GUICtrlSetOnEvent( $SaveGeneral, "SaveGeneral" )
	GUICtrlSetState( $SaveGeneral, $GUI_DISABLE )
EndFunc

Func MouseButtons()
	If @GUI_CTRLID = $idMouseButtons1 Then
		$fSwapMouseButtonsNew = False
	Else
		$fSwapMouseButtonsNew = True
	EndIf
	UpdateMouseButtons()
EndFunc

Func UpdateMouseButtons()
	If Not $fSwapMouseButtonsNew Then
		GUICtrlSetState( $idMouseButtons1, $GUI_CHECKED )
		GUICtrlSetState( $idMouseButtons2, $GUI_UNCHECKED )
	Else
		GUICtrlSetState( $idMouseButtons1, $GUI_UNCHECKED )
		GUICtrlSetState( $idMouseButtons2, $GUI_CHECKED )
	EndIf
	If $fSwapMouseButtons <> $fSwapMouseButtonsNew Then
		$fNewValues = BitOR( $fNewValues, 1 )
	Else
		If BitAND( $fNewValues, 1 ) Then _
			$fNewValues = BitXOR( $fNewValues, 1 )
	EndIf
	CheckNewValues()
EndFunc

Func RotateLayerSpeed()
	Switch @GUI_CTRLID
		Case $idRotateLayerSlow
			$nDeltaDegreesNew = 3
		Case $idRotateLayerMedium
			$nDeltaDegreesNew = 6
		Case $idRotateLayerFast
			$nDeltaDegreesNew = 9
	EndSwitch
	UpdateRotateLayerSpeed()
EndFunc

Func UpdateRotateLayerSpeed()
	Switch $nDeltaDegreesNew
		Case 3
			GUICtrlSetState( $idRotateLayerSlow,   $GUI_CHECKED )
			GUICtrlSetState( $idRotateLayerMedium, $GUI_UNCHECKED )
			GUICtrlSetState( $idRotateLayerFast,   $GUI_UNCHECKED )
		Case 6
			GUICtrlSetState( $idRotateLayerSlow,   $GUI_UNCHECKED )
			GUICtrlSetState( $idRotateLayerMedium, $GUI_CHECKED )
			GUICtrlSetState( $idRotateLayerFast,   $GUI_UNCHECKED )
		Case 9
			GUICtrlSetState( $idRotateLayerSlow,   $GUI_UNCHECKED )
			GUICtrlSetState( $idRotateLayerMedium, $GUI_UNCHECKED )
			GUICtrlSetState( $idRotateLayerFast,   $GUI_CHECKED )
	EndSwitch
	If $nDeltaDegrees <> $nDeltaDegreesNew Then
		$fNewValues = BitOR( $fNewValues, 2 )
	Else
		If BitAND( $fNewValues, 2 ) Then _
			$fNewValues = BitXOR( $fNewValues, 2 )
	EndIf
	CheckNewValues()
EndFunc

Func SimulateLayerRotations()
	If GUICtrlRead( $idSimulateLayerRotations ) = $GUI_CHECKED Then
		$fSimulateLayerRotationsNew = True
	Else
		$fSimulateLayerRotationsNew = False
	EndIf
	UpdateSimulateLayerRotations()
EndFunc

Func UpdateSimulateLayerRotations()
	If $fSimulateLayerRotations <> $fSimulateLayerRotationsNew Then
		$fNewValues = BitOR( $fNewValues, 4 )
	Else
		If BitAND( $fNewValues, 4 ) Then _
			$fNewValues = BitXOR( $fNewValues, 4 )
	EndIf
	CheckNewValues()
EndFunc

Func ScrambleStepsCube()
	Local $ctrl, $index
	Switch GuiCtrlGetFocus( $hGeneralWin )
		Case $idScrambleStepsCube2
			$ctrl = $idScrambleStepsCube2
			$index = 1
		Case $idScrambleStepsCube3
			$ctrl = $idScrambleStepsCube3
			$index = 2
		Case $idScrambleStepsCube4
			$ctrl = $idScrambleStepsCube4
			$index = 3
		Case $idScrambleStepsCube5
			$ctrl = $idScrambleStepsCube5
			$index = 4
		Case $idScrambleStepsCube6
			$ctrl = $idScrambleStepsCube6
			$index = 5
		Case $idScrambleStepsCube7
			$ctrl = $idScrambleStepsCube7
			$index = 6
	EndSwitch
	ScrambleStepsCubeRead( $ctrl, $index )
EndFunc

Func ScrambleStepsCubeRead( $ctrl, $index )
	Local $s = GUICtrlRead( $ctrl )
	If $s <> "" Then
		If StringIsInt( $s ) And $s >= 1 And $s <= 200 Then
			$aNewScrambleStepsCubes[$index] = Number( $s )
		Else
			GUICtrlSetData( $ctrl, $aScrambleStepsCubes[$index] )
			$aNewScrambleStepsCubes[$index] = $aScrambleStepsCubes[$index]
		EndIf
	Else
		GUICtrlSetData( $ctrl, $aScrambleStepsCubes[$index] )
		$aNewScrambleStepsCubes[$index] = $aScrambleStepsCubes[$index]
	EndIf
	CheckNewScrambleSteps()
EndFunc

Func CheckNewScrambleSteps()
	For $i = 1 To 6
		If $aScrambleStepsCubes[$i] <> $aNewScrambleStepsCubes[$i] Then
			ExitLoop
		EndIf
	Next
	If $i = 7 Then
		; All values matches
		If BitAND( $fNewValues, 8 ) Then _
			$fNewValues = BitXOR( $fNewValues, 8 )
	Else
		$fNewValues = BitOR( $fNewValues, 8 )
	EndIf
	CheckNewValues()
EndFunc

Func DefaultGeneral()
	$fSwapMouseButtons = False
	$fSwapMouseButtonsNew = $fSwapMouseButtons
	GUICtrlSetState( $idMouseButtons1, $GUI_CHECKED )
	GUICtrlSetState( $idMouseButtons2, $GUI_UNCHECKED )

	$nDeltaDegrees = 3
	$nDeltaDegreesNew = $nDeltaDegrees
	GUICtrlSetState( $idRotateLayerSlow,   $GUI_CHECKED )
	GUICtrlSetState( $idRotateLayerMedium, $GUI_UNCHECKED )
	GUICtrlSetState( $idRotateLayerFast,   $GUI_UNCHECKED )

	$fSimulateLayerRotations = True
	$fSimulateLayerRotationsNew = $fSimulateLayerRotations
	GUICtrlSetState( $idSimulateLayerRotations, $GUI_CHECKED )

	If $aScrambleStepsCubes[$iSize-1] <> $aDefScrambleStepsCubes[$iSize-1] Then _
		$fNewScrambleStepsValues = True
	$aScrambleStepsCubes = $aDefScrambleStepsCubes
	$aNewScrambleStepsCubes = $aScrambleStepsCubes
	GUICtrlSetData( $idScrambleStepsCube2, $aScrambleStepsCubes[1] )
	GUICtrlSetData( $idScrambleStepsCube3, $aScrambleStepsCubes[2] )
	GUICtrlSetData( $idScrambleStepsCube4, $aScrambleStepsCubes[3] )
	GUICtrlSetData( $idScrambleStepsCube5, $aScrambleStepsCubes[4] )
	GUICtrlSetData( $idScrambleStepsCube6, $aScrambleStepsCubes[5] )
	GUICtrlSetData( $idScrambleStepsCube7, $aScrambleStepsCubes[6] )

	GUICtrlSetState( $DefaultGeneral, $GUI_DISABLE )
	GUICtrlSetState( $UndoGeneral, $GUI_DISABLE )
	GUICtrlSetState( $SaveGeneral, $GUI_DISABLE )
	$fNewValues = 0
EndFunc

Func UndoGeneral()
	If BitAND( $fNewValues, 1 ) Then
		$fSwapMouseButtonsNew = $fSwapMouseButtons
		UpdateMouseButtons()
	EndIf
	If BitAND( $fNewValues, 2 ) Then
		$nDeltaDegreesNew = $nDeltaDegrees
		UpdateRotateLayerSpeed()
	EndIf
	If BitAND( $fNewValues, 4 ) Then
		$fSimulateLayerRotationsNew = $fSimulateLayerRotations
		If $fSimulateLayerRotations Then
			GUICtrlSetState( $idSimulateLayerRotations, $GUI_CHECKED )
		Else
			GUICtrlSetState( $idSimulateLayerRotations, $GUI_UNCHECKED )
		EndIf
		UpdateSimulateLayerRotations()
	EndIf
	If BitAND( $fNewValues, 8 ) Then
		$aNewScrambleStepsCubes = $aScrambleStepsCubes
		GUICtrlSetData( $idScrambleStepsCube2, $aScrambleStepsCubes[1] )
		GUICtrlSetData( $idScrambleStepsCube3, $aScrambleStepsCubes[2] )
		GUICtrlSetData( $idScrambleStepsCube4, $aScrambleStepsCubes[3] )
		GUICtrlSetData( $idScrambleStepsCube5, $aScrambleStepsCubes[4] )
		GUICtrlSetData( $idScrambleStepsCube6, $aScrambleStepsCubes[5] )
		GUICtrlSetData( $idScrambleStepsCube7, $aScrambleStepsCubes[6] )
		$fNewValues = BitXOR( $fNewValues, 8 )
		CheckNewValues()
	EndIf
EndFunc

Func SaveGeneral()
	If BitAND( $fNewValues, 1 ) Then
		$fSwapMouseButtons = $fSwapMouseButtonsNew
		UpdateMouseButtons()
	EndIf
	If BitAND( $fNewValues, 2 ) Then
		$nDeltaDegrees = $nDeltaDegreesNew
		UpdateRotateLayerSpeed()
	EndIf
	If BitAND( $fNewValues, 4 ) Then
		$fSimulateLayerRotations = $fSimulateLayerRotationsNew
		If $fSimulateLayerRotations Then
			GUICtrlSetState( $idSimulateLayerRotations, $GUI_CHECKED )
		Else
			GUICtrlSetState( $idSimulateLayerRotations, $GUI_UNCHECKED )
		EndIf
		UpdateSimulateLayerRotations()
	EndIf
	If BitAND( $fNewValues, 8 ) Then
		If $aScrambleStepsCubes[$iSize-1] <> $aNewScrambleStepsCubes[$iSize-1] Then _
			$fNewScrambleStepsValues = True
		$aScrambleStepsCubes = $aNewScrambleStepsCubes
		$fNewValues = BitXOR( $fNewValues, 8 )
		CheckNewValues()
	EndIf
	CheckDefValues()
EndFunc

Func CheckDefValues( $fWin = True )
	If $fSwapMouseButtons <> False Then
		If $fWin Then GUICtrlSetState( $DefaultGeneral, $GUI_ENABLE )
		Return False
	EndIf
	If $nDeltaDegrees <> 3 Then
		If $fWin Then GUICtrlSetState( $DefaultGeneral, $GUI_ENABLE )
		Return False
	EndIf
	If $fSimulateLayerRotations <> True Then
		If $fWin Then GUICtrlSetState( $DefaultGeneral, $GUI_ENABLE )
		Return False
	EndIf
	For $i = 1 To 6
		If $aScrambleStepsCubes[$i] <> $aDefScrambleStepsCubes[$i] Then
			If $fWin Then GUICtrlSetState( $DefaultGeneral, $GUI_ENABLE )
			Return False
		EndIf
	Next
	If $fWin Then GUICtrlSetState( $DefaultGeneral, $GUI_DISABLE )
	Return True
EndFunc

Func CheckIniValues()
	If $fSwapMouseButtons <> $fSwapMouseButtonsIni Then _
		Return False
	If $nDeltaDegrees <> $nDeltaDegreesIni Then _
		Return False
	If $fSimulateLayerRotations <> $fSimulateLayerRotationsIni Then _
		Return False
	For $i = 1 To 6
		If $aScrambleStepsCubes[$i] <> $aIniScrambleStepsCubes[$i] Then _
			Return False
	Next
	Return True
EndFunc

Func CheckNewValues()
	If $fNewValues Then
		GUICtrlSetState( $UndoGeneral, $GUI_ENABLE )
		GUICtrlSetState( $SaveGeneral, $GUI_ENABLE )
	Else
		GUICtrlSetState( $UndoGeneral, $GUI_DISABLE )
		GUICtrlSetState( $SaveGeneral, $GUI_DISABLE )
	EndIf
EndFunc

Func SaveValuesToInifile()
	Local $name = StringLeft( @ScriptName, StringInStr( @ScriptName, ".", 0, -1 ) - 1 )
	Local $iniName = @ScriptDir & "\" & $name & ".ini"
	If $fSwapMouseButtons <> $fSwapMouseButtonsIni Then
		Local $i = 0
		If $fSwapMouseButtons Then $i = 1
		Local $iniData[1][2] = [ [ "fSwapMouseButtons", $i ] ]
		IniWriteSection( $iniName, "SwapMouseButtons", $iniData, 0 )
	EndIf
	If $nDeltaDegrees <> $nDeltaDegreesIni Then
		Local $iniData[1][2] = [ [ "nDeltaDegrees", $nDeltaDegrees ] ]
		IniWriteSection( $iniName, "DeltaDegrees", $iniData, 0 )
	EndIf
	If $fSimulateLayerRotations <> $fSimulateLayerRotationsIni Then
		Local $i = 0
		If $fSimulateLayerRotations Then $i = 1
		Local $iniData[1][2] = [ [ "fSimulateLayerRotations", $i ] ]
		IniWriteSection( $iniName, "SimulateLayerRotations", $iniData, 0 )
	EndIf
	For $i = 1 To 6
		If $aScrambleStepsCubes[$i] <> $aIniScrambleStepsCubes[$i] Then
			Local $iniData[6][2] = [ _
				[ "Pocket",    $aScrambleStepsCubes[1] ], _
				[ "Rubik",     $aScrambleStepsCubes[2] ], _
				[ "Revenge",   $aScrambleStepsCubes[3] ], _
				[ "Professor", $aScrambleStepsCubes[4] ], _
				[ "V-Cube6",   $aScrambleStepsCubes[5] ], _
				[ "V-Cube7",   $aScrambleStepsCubes[6] ] ]
			IniWriteSection( $iniName, "ScrambleSteps", $iniData, 0 )
			ExitLoop
		EndIf
	Next
EndFunc

Func ReadValuesFromInifile()
	Local $iniData, $fError
	Local $name = StringLeft( @ScriptName, StringInStr( @ScriptName, ".", 0, -1 ) - 1 )
	Local $iniName = @ScriptDir & "\" & $name & ".ini"
	If Not FileExists( $iniName ) Then Return

	$fError = False
	$iniData = IniReadSection( $iniName, "SwapMouseButtons" )
	If Not @error Then
		If $iniData[0][0] <> 1 Then
			$fError = True
		Else
			Local $value, $error
			If StringIsInt( $iniData[1][1] ) Then
				$value = Number( $iniData[1][1] )
				If $value >= 0 And $value <= 1 Then
					$error = False
				Else
					$error = True
				EndIf
			Else
				$error = True
			EndIf
			If $error Then _
				$fError = True
			If Not $fError Then
				Switch $iniData[1][0]
					Case "fSwapMouseButtons"
						If $value Then
							$fSwapMouseButtonsIni = True
						Else
							$fSwapMouseButtonsIni = False
						EndIf
					Case Else
						$fError = True
				EndSwitch
			EndIf
		EndIf
	EndIf
	If $fError Then
		$fSwapMouseButtonsIni = False
		MsgBox( 48, "Rubik's Cube: Error reading inifile", _
						"Error occurred reading ""SwapMouseButtons"" section." & @CRLF & _
						"Using default mouse buttons.", 0, $hGui )
	EndIf
	$fSwapMouseButtonsNew = $fSwapMouseButtonsIni
	$fSwapMouseButtons = $fSwapMouseButtonsNew

	$fError = False
	$iniData = IniReadSection( $iniName, "DeltaDegrees" )
	If Not @error Then
		If $iniData[0][0] <> 1 Then
			$fError = True
		Else
			Local $value, $error
			If StringIsInt( $iniData[1][1] ) Then
				$value = Number( $iniData[1][1] )
				If $value = 3 Or $value = 6 Or $value = 9 Then
					$error = False
				Else
					$error = True
				EndIf
			Else
				$error = True
			EndIf
			If $error Then _
				$fError = True
			If Not $fError Then
				Switch $iniData[1][0]
					Case "nDeltaDegrees"
						$nDeltaDegreesIni = $value
					Case Else
						$fError = True
				EndSwitch
			EndIf
		EndIf
	EndIf
	If $fError Then
		$nDeltaDegreesIni = 3
		MsgBox( 48, "Rubik's Cube: Error reading inifile", _
						"Error occurred reading ""DeltaDegrees"" section." & @CRLF & _
						"Using default value.", 0, $hGui )
	EndIf
	$nDeltaDegreesNew = $nDeltaDegreesIni
	$nDeltaDegrees = $nDeltaDegreesNew

	$fError = False
	$iniData = IniReadSection( $iniName, "SimulateLayerRotations" )
	If Not @error Then
		If $iniData[0][0] <> 1 Then
			$fError = True
		Else
			Local $value, $error
			If StringIsInt( $iniData[1][1] ) Then
				$value = Number( $iniData[1][1] )
				If $value >= 0 And $value <= 1 Then
					$error = False
				Else
					$error = True
				EndIf
			Else
				$error = True
			EndIf
			If $error Then _
				$fError = True
			If Not $fError Then
				Switch $iniData[1][0]
					Case "fSimulateLayerRotations"
						If $value Then
							$fSimulateLayerRotationsIni = True
						Else
							$fSimulateLayerRotationsIni = False
						EndIf
					Case Else
						$fError = True
				EndSwitch
			EndIf
		EndIf
	EndIf
	If $fError Then
		$fSimulateLayerRotationsIni = True
		MsgBox( 48, "Rubik's Cube: Error reading inifile", _
						"Error occurred reading ""SimulateLayerRotations"" section." & @CRLF & _
						"Using default value.", 0, $hGui )
	EndIf
	$fSimulateLayerRotationsNew = $fSimulateLayerRotationsIni
	$fSimulateLayerRotations = $fSimulateLayerRotationsNew

	$fError = False
	$iniData = IniReadSection( $iniName, "ScrambleSteps" )
	If Not @error Then
		If $iniData[0][0] <> 6 Then
			$fError = True
		Else
			Local $nSteps, $error
			For $i = 1 To $iniData[0][0]
				If StringIsInt( $iniData[$i][1] ) Then
					$nSteps = Number( $iniData[$i][1] )
					If $nSteps >= 1 And $nSteps <= 200 Then
						$error = False
					Else
						$error = True
					EndIf
				Else
					$error = True
				EndIf
				If $error Then 
					$fError = True
					ExitLoop
				EndIf
				Switch $iniData[$i][0]
					Case "Pocket"
						$aIniScrambleStepsCubes[1] = $nSteps
					Case "Rubik"
						$aIniScrambleStepsCubes[2] = $nSteps
					Case "Revenge"
						$aIniScrambleStepsCubes[3] = $nSteps
					Case "Professor"
						$aIniScrambleStepsCubes[4] = $nSteps
					Case "V-Cube6"
						$aIniScrambleStepsCubes[5] = $nSteps
					Case "V-Cube7"
						$aIniScrambleStepsCubes[6] = $nSteps
					Case Else
						$fError = True
						ExitLoop
				EndSwitch
			Next
		EndIf
	EndIf
	If $fError Then
		$aIniScrambleStepsCubes = $aDefScrambleStepsCubes
		MsgBox( 48, "Rubik's Cube: Error reading inifile", _
						"Error occurred reading ""ScrambleSteps"" section." & @CRLF & _
						"Using default scramble step values.", 0, $hGui )
	EndIf
	$aNewScrambleStepsCubes = $aIniScrambleStepsCubes
	$aScrambleStepsCubes = $aNewScrambleStepsCubes
EndFunc

Func DelValuesFromInifile()
	Local $name = StringLeft( @ScriptName, StringInStr( @ScriptName, ".", 0, -1 ) - 1 )
	Local $iniName = @ScriptDir & "\" & $name & ".ini"
	IniDelete( $iniName, "SwapMouseButtons" )
	IniDelete( $iniName, "DeltaDegrees" )
	IniDelete( $iniName, "SimulateLayerRotations" )
	IniDelete( $iniName, "ScrambleSteps" )
EndFunc

; --- Colors ---

Func CreateColorsWinControls()
	GUICtrlCreateGroup( "Colors", 10, 10, 480, 270 )

	$TopColor = GUICtrlCreateButton( "Top", 100,  30, 80, 80 )
	GUICtrlSetBkColor( $TopColor, $aColors[2] )
	GUICtrlSetOnEvent( $TopColor, "SetColor" )
	GUICtrlSetTip( $TopColor, "Top" )

	Local $s = "If a button is too dark to read the text move the cursor over the button."
	GUICtrlCreateLabel( $s, 200, 50, 140, 45 )

	$LeftColor = GUICtrlCreateButton( "Left (x)", 20, 110, 80, 80 )
	GUICtrlSetBkColor( $LeftColor, $aColors[1] )
	GUICtrlSetOnEvent( $LeftColor, "SetColor" )
	GUICtrlSetTip( $LeftColor, "Left (x)" )

	$FrontColor = GUICtrlCreateButton( "Front", 100, 110, 80, 80 )
	GUICtrlSetBkColor( $FrontColor, $aColors[4] )
	GUICtrlSetOnEvent( $FrontColor, "SetColor" )
	GUICtrlSetTip( $FrontColor, "Front" )

	$RightColor = GUICtrlCreateButton( "Right", 180, 110, 80, 80 )
	GUICtrlSetBkColor( $RightColor, $aColors[0] )
	GUICtrlSetOnEvent( $RightColor, "SetColor" )
	GUICtrlSetTip( $RightColor, "Right" )

	$BackColor = GUICtrlCreateButton( "Back (z)", 260, 110, 80, 80 )
	GUICtrlSetBkColor( $BackColor, $aColors[5] )
	GUICtrlSetOnEvent( $BackColor, "SetColor" )
	GUICtrlSetTip( $BackColor, "Back (z)" )

	$BottomColor = GUICtrlCreateButton( "Bottom (y)", 100, 190, 80, 80 )
	GUICtrlSetBkColor( $BottomColor, $aColors[3] )
	GUICtrlSetOnEvent( $BottomColor, "SetColor" )
	GUICtrlSetTip( $BottomColor, "Bottom (y)" )

	Local $s = "Sides marked x, y and z are reference sides in undo and redo logs."
	GUICtrlCreateLabel( $s, 200, 210, 140, 45 )

	$CornerColor = GUICtrlCreateButton( "Corners", 350, 110, 130, 35 )
	GUICtrlSetBkColor( $CornerColor, $aColors[6] )
	GUICtrlSetOnEvent( $CornerColor, "SetColor" )
	GUICtrlSetTip( $CornerColor, "Corners" )

	$BackGrColor = GUICtrlCreateButton( "Back ground", 350, 155, 130, 35 )
	GUICtrlSetBkColor( $BackGrColor, $aColors[7] )
	GUICtrlSetOnEvent( $BackGrColor, "SetColor" )
	GUICtrlSetTip( $BackGrColor, "Back ground" )

	GUICtrlCreateGroup( "", -99, -99, 1, 1 )

	Local $s = "Color settings are applied when a new cube is selected in the Cubes menu."
	GUICtrlCreateLabel( "", 10, 300, 480, 30, $SS_GRAYFRAME )
	GUICtrlCreateLabel( $s, 12, 308, 476, 15 )

	$DefaultColors = GUICtrlCreateButton( "Defaults", 60, 350, 130, 30 )
	GUICtrlSetOnEvent( $DefaultColors, "DefaultColors" )
	CheckDefColors()

	$UndoColors = GUICtrlCreateButton( "Undo", 210, 350, 130, 30 )
	GUICtrlSetOnEvent( $UndoColors, "UndoColors" )
	;CheckNewColors()

	$SaveColors = GUICtrlCreateButton( "Save", 360, 350, 130, 30 )
	GUICtrlSetOnEvent( $SaveColors, "SaveColors" )
	CheckNewColors()
EndFunc

Func SetColor()
	Local $index, $nColor
	Switch @GUI_CTRLID
		Case $RightColor
			$index = 0
		Case $LeftColor
			$index = 1
		Case $TopColor
			$index = 2
		Case $BottomColor
			$index = 3
		Case $FrontColor
			$index = 4
		Case $BackColor
			$index = 5
		Case $CornerColor
			$index = 6
		Case $BackGrColor
			$index = 7
	EndSwitch
	$nColor = _ChooseColor( 0, ColorConvert( $aNewColors[$index] ), 0, $hOptionsWin )
	If $nColor > -1 And ColorConvert( $nColor ) <> $aNewColors[$index] Then
		$nColor = ColorConvert( $nColor )
		GUICtrlSetBkColor( @GUI_CTRLID, $nColor )
		$aNewColors[$index] = $nColor
		CheckNewColors()
	EndIf
EndFunc

Func DefaultColors()
	GUICtrlSetState( $DefaultColors, $GUI_DISABLE )
	GUICtrlSetState( $UndoColors, $GUI_DISABLE )
	GUICtrlSetState( $SaveColors, $GUI_DISABLE )
	$aNewColors = $aDefColors
	$aColors = $aNewColors
	$fNewColors = True
	SetButtonColors()
EndFunc

Func UndoColors()
	GUICtrlSetState( $UndoColors, $GUI_DISABLE )
	GUICtrlSetState( $SaveColors, $GUI_DISABLE )
	$aNewColors = $aColors
	SetButtonColors()
EndFunc

Func SetButtonColors()
	GUICtrlSetBkColor( $RightColor,  $aColors[0] )
	GUICtrlSetBkColor( $LeftColor,   $aColors[1] )
	GUICtrlSetBkColor( $TopColor,    $aColors[2] )
	GUICtrlSetBkColor( $BottomColor, $aColors[3] )
	GUICtrlSetBkColor( $FrontColor,  $aColors[4] )
	GUICtrlSetBkColor( $BackColor,   $aColors[5] )
	GUICtrlSetBkColor( $CornerColor, $aColors[6] )
	GUICtrlSetBkColor( $BackGrColor, $aColors[7] )
EndFunc

Func SaveColors()
	GUICtrlSetState( $UndoColors, $GUI_DISABLE )
	GUICtrlSetState( $SaveColors, $GUI_DISABLE )
	$aColors = $aNewColors
	$fNewColors = True
	CheckDefColors()
EndFunc

Func CheckDefColors( $fWin = True )
	For $i = 0 To 7
		If $aColors[$i] <> $aDefColors[$i] Then
			If $fWin Then GUICtrlSetState( $DefaultColors, $GUI_ENABLE )
			Return False
		EndIf
	Next
	If $fWin Then GUICtrlSetState( $DefaultColors, $GUI_DISABLE )
	Return True
EndFunc

Func CheckIniColors()
	For $i = 0 To 7
		If $aColors[$i] <> $aIniColors[$i] Then _
			Return False
	Next
	Return True
EndFunc

Func CheckNewColors()
	For $i = 0 To 7
		If $aColors[$i] <> $aNewColors[$i] Then
			GUICtrlSetState( $UndoColors, $GUI_ENABLE )
			GUICtrlSetState( $SaveColors, $GUI_ENABLE )
			Return
		EndIf
	Next
	GUICtrlSetState( $UndoColors, $GUI_DISABLE )
	GUICtrlSetState( $SaveColors, $GUI_DISABLE )
EndFunc

Func SaveColorsToInifile()
	Local $name = StringLeft( @ScriptName, StringInStr( @ScriptName, ".", 0, -1 ) - 1 )
	Local $iniName = @ScriptDir & "\" & $name & ".ini"
	Local $iniData[8][2] = [ _
		[ "RightColor",  $aColors[0] ], _
		[ "LeftColor",   $aColors[1] ], _
		[ "TopColor",    $aColors[2] ], _
		[ "BottomColor", $aColors[3] ], _
		[ "FrontColor",  $aColors[4] ], _
		[ "BackColor",   $aColors[5] ], _
		[ "CornerColor", $aColors[6] ], _
		[ "BackGrColor", $aColors[7] ] ]
	IniWriteSection( $iniName, "Colors", $iniData, 0 )
EndFunc

Func ReadColorsFromInifile()
	Local $name = StringLeft( @ScriptName, StringInStr( @ScriptName, ".", 0, -1 ) - 1 )
	Local $iniName = @ScriptDir & "\" & $name & ".ini"
	If Not FileExists( $iniName ) Then Return
	Local $iniData = IniReadSection( $iniName, "Colors" )
	If @error Then
		Return
	Else
		If $iniData[0][0] <> 8 Then
			MsgBox( 48, "Rubik's Cube: Error reading inifile", _
			        "Error occurred reading ""Colors"" section." & @CRLF & _
							"Using default color values.", 0, $hGui )
			Return
		Else
			Local $nColor, $error
			For $i = 1 To $iniData[0][0]
				If StringIsInt( $iniData[$i][1] ) Then
					$nColor = Number( $iniData[$i][1] )
					If $nColor >= 0 And $nColor <= 16777215 Then
						$error = False
					Else
						$error = True
					EndIf
				Else
					$error = True
				EndIf
				If $error Then 
					MsgBox( 48, "Rubik's Cube: Error reading inifile", _
									"Error occurred reading ""Colors"" section." & @CRLF & _
									"Using default color values.", 0, $hGui )
					Return
				EndIf
				Switch $iniData[$i][0]
					Case "RightColor"
						$aIniColors[0] = $nColor
					Case "LeftColor"
						$aIniColors[1] = $nColor
					Case "TopColor"
						$aIniColors[2] = $nColor
					Case "BottomColor"
						$aIniColors[3] = $nColor
					Case "FrontColor"
						$aIniColors[4] = $nColor
					Case "BackColor"
						$aIniColors[5] = $nColor
					Case "CornerColor"
						$aIniColors[6] = $nColor
					Case "BackGrColor"
						$aIniColors[7] = $nColor
					Case Else
						MsgBox( 48, "Rubik's Cube: Error reading inifile", _
						        "Error occurred reading ""Colors"" section." & @CRLF & _
										"Using default color values.", 0, $hGui )
						Return
				EndSwitch
			Next
			$aNewColors = $aIniColors
			$aColors = $aNewColors
			NewColors()
		EndIf
	EndIf
EndFunc

Func DelColorsFromInifile()
	Local $name = StringLeft( @ScriptName, StringInStr( @ScriptName, ".", 0, -1 ) - 1 )
	Local $iniName = @ScriptDir & "\" & $name & ".ini"
	IniDelete( $iniName, "Colors" )
EndFunc

;RGB to BGR or BGR to RGB
Func ColorConvert($iColor)
	Return BitOR(BitAND($iColor, 0x00FF00), BitShift(BitAND($iColor, 0x0000FF), -16), BitShift(BitAND($iColor, 0xFF0000), 16))
EndFunc


#cs################
#   Help window   #
#ce################

Global $hHelpWin = 0, $idHelpTab, $hRichEdit, $idPic

Func HelpWin()
	If $hHelpWin Then
		GUISetState( @SW_SHOW, $hHelpWin )
	Else
		Local $iWidth = 828, $iHeigth = 672, $aPos = WinGetPos( $hGui )
		Local $x = $aPos[0]+($aPos[2]-$iWidth)/2, $y = $aPos[1]+($aPos[3]-$iHeigth)/2
		$hHelpWin = GUICreate( "Cube Help", $iWidth, $iHeigth, $x, $y, $DS_MODALFRAME + $WS_SYSMENU )
		GUISetOnEvent( $GUI_EVENT_CLOSE, "HideHelpWin", $hHelpWin )
		GUISetIcon( "res\RubiksCube.ico" )
		HelpWinControls()
		GUISetState()
	EndIf
EndFunc

Func CloseHelpWin()
	_GUICtrlRichEdit_Destroy( $hRichEdit )
	GUIDelete( $hHelpWin )
EndFunc

Func HideHelpWin()
	GUISetState( @SW_HIDE, $hHelpWin )
EndFunc

Func HelpWinControls()
	$idHelpTab = GUICtrlCreateTab( 5, 5, 812, 632 )
	GUICtrlCreateTabItem( "Cubes" )
	GUICtrlSetState( -1, $GUI_SHOW )
	GUICtrlCreateTabItem( "Main menus" )
	GUICtrlCreateTabItem( "Other menus" )
	GUICtrlCreateTabItem( "Mouse rotations" )
	GUICtrlCreateTabItem( "Keyboard shortcuts" )
	GUICtrlCreateTabItem("")

	GUICtrlSetOnEvent( $idHelpTab, "HelpTab" )

	$hRichEdit = _GUICtrlRichEdit_Create( $hHelpWin, "", 10, 30, 800, 600, BitOR( $ES_AUTOVSCROLL, $ES_MULTILINE, $WS_VSCROLL ) )
	_GUICtrlRichEdit_SetEventMask( $hRichEdit, $ENM_LINK )
	_GUICtrlRichEdit_AutoDetectURL( $hRichEdit, True )
	_GUICtrlRichEdit_SetReadOnly( $hRichEdit, True )

	$idPic = GUICtrlCreatePic( "res\RubiksCube.jpg", 550, 400, 243, 215 )

	GUIRegisterMsg( $WM_NOTIFY, "WM_NOTIFY" )

	_GUICtrlRichEdit_StreamFromFile( $hRichEdit, "res\HelpCubes.rtf" )
	_WinAPI_RedrawWindow( $hHelpWin, 0, 0, $RDW_ERASE + $RDW_INVALIDATE )
	_GUICtrlRichEdit_GotoCharPos( $hRichEdit, 0 )
EndFunc

Func HelpTab()
	Switch GUICtrlRead( $idHelpTab )
		Case 0
			GUICtrlSetState( $idPic, $GUI_SHOW )
			GUICtrlSetPos( $idPic, 550, 400, 243, 215 )
			_GUICtrlRichEdit_StreamFromFile( $hRichEdit, "res\HelpCubes.rtf" )
		Case 1
			GUICtrlSetState( $idPic, $GUI_HIDE )
			_GUICtrlRichEdit_StreamFromFile( $hRichEdit, "res\HelpMenu1.rtf" )
		Case 2
			GUICtrlSetState( $idPic, $GUI_HIDE )
			_GUICtrlRichEdit_StreamFromFile( $hRichEdit, "res\HelpMenu2.rtf" )
		Case 3
			GUICtrlSetState( $idPic, $GUI_SHOW )
			GUICtrlSetPos( $idPic, 550, 170, 243, 215 )
			_GUICtrlRichEdit_StreamFromFile( $hRichEdit, "res\HelpMouse.rtf" )
		Case 4
			GUICtrlSetState( $idPic, $GUI_HIDE )
			_GUICtrlRichEdit_StreamFromFile( $hRichEdit, "res\HelpKeyboard.rtf" )
	EndSwitch
	_WinAPI_RedrawWindow( $hHelpWin, 0, 0, $RDW_ERASE + $RDW_INVALIDATE )
	_GUICtrlRichEdit_GotoCharPos( $hRichEdit, 0 )
EndFunc

Func WM_NOTIFY( $hWnd, $iMsg, $iwParam, $ilParam )
	#forceref $hWnd, $iMsg, $iwParam
	Local $hWndFrom, $iCode, $tNMHDR, $tEnLink, $cpMin, $cpMax, $tMsgFilter, $sLink
	$tNMHDR = DllStructCreate( $tagNMHDR, $ilParam )
	$hWndFrom = HWnd( DllStructGetData( $tNMHDR, "hWndFrom" ) )
	$iCode = DllStructGetData( $tNMHDR, "Code" )
	Switch $hWndFrom
		Case $hRichEdit
			Switch $iCode
				Case $EN_LINK
					$tMsgFilter = DllStructCreate( $tagMSGFILTER, $ilParam )
					If DllStructGetData( $tMsgFilter, "msg" ) = $WM_LBUTTONUP Then
						$tEnLink = DllStructCreate( $tagENLINK, $ilParam )
						$cpMin = DllStructGetData( $tEnLink, "cpMin" )
						$cpMax = DllStructGetData( $tEnLink, "cpMax" )
						$sLink = _GUICtrlRichEdit_GetTextInRange( $hRichEdit, $cpMin, $cpMax )
						ShellExecute( $sLink )
					EndIf
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc
