; See http://www.autoitscript.com/forum/index.php?showtopic=83581 by trancexx

#include-once

Func EnableOpenGL( $hWnd, ByRef $hDeviceContext, ByRef $hOPENGL32RenderingContext )

	Local $tPIXELFORMATDESCRIPTOR = DllStructCreate( _
		"word  Size;" & _
		"word  Version;" & _
		"dword Flags;" & _
		"byte  PixelType;" & _
		"byte  ColorBits;" & _
		"byte  RedBits;" & _
		"byte  RedShift;" & _
		"byte  GreenBits;" & _
		"byte  GreenShift;" & _
		"byte  BlueBits;" & _
		"byte  BlueShift;" & _
		"byte  AlphaBits;" & _
		"byte  AlphaShift;" & _
		"byte  AccumBits;" & _
		"byte  AccumRedBits;" & _
		"byte  AccumGreenBits;" & _
		"byte  AccumBlueBits;" & _
		"byte  AccumAlphaBits;" & _
		"byte  DepthBits;" & _
		"byte  StencilBits;" & _
		"byte  AuxBuffers;" & _
		"byte  LayerType;" & _
		"byte  Reserved;" & _
		"dword LayerMask;" & _
		"dword VisibleMask;" & _
		"dword DamageMask" )

	DllStructSetData( $tPIXELFORMATDESCRIPTOR, "Size", DllStructGetSize( $tPIXELFORMATDESCRIPTOR ) )
	DllStructSetData( $tPIXELFORMATDESCRIPTOR, "Version", $GL_VERSION_1_1 )
	DllStructSetData( $tPIXELFORMATDESCRIPTOR, "Flags", BitOR( $PFD_DRAW_TO_WINDOW, $PFD_SUPPORT_OPENGL, $PFD_DOUBLEBUFFER ) )
	DllStructSetData( $tPIXELFORMATDESCRIPTOR, "PixelType", $PFD_TYPE_RGBA )
	DllStructSetData( $tPIXELFORMATDESCRIPTOR, "ColorBits", 24 )
	DllStructSetData( $tPIXELFORMATDESCRIPTOR, "DepthBits", 32 )
	DllStructSetData( $tPIXELFORMATDESCRIPTOR, "LayerType", $PFD_MAIN_PLANE )

	Local $aRet = DllCall( $dllUser32, "hwnd", "GetDC", "hwnd", $hWnd )
	If @error Or Not $aRet[0] Then Return SetError(1,0,0)

	$hDeviceContext = $aRet[0]

	$aRet = DllCall( $dllGDI32, "int", "ChoosePixelFormat", "hwnd", $hDeviceContext, "ptr", DllStructGetPtr( $tPIXELFORMATDESCRIPTOR ) )
	If @error Or Not $aRet[0] Then Return SetError(2,0,0)
	Local $iFormat = $aRet[0]

	$aRet = DllCall( $dllGDI32, "int", "SetPixelFormat", "hwnd", $hDeviceContext, "int", $iFormat, "ptr", DllStructGetPtr( $tPIXELFORMATDESCRIPTOR ) )
	If @error Or Not $aRet[0] Then Return SetError(3,0,0)

	$aRet = DllCall( $dllOpenGL32, "hwnd", "wglCreateContext", "hwnd", $hDeviceContext )
	If @error Or Not $aRet[0] Then Return SetError(4,0,0)

	$hOPENGL32RenderingContext = $aRet[0]

	$aRet = DllCall( $dllOpenGL32, "int", "wglMakeCurrent", "hwnd", $hDeviceContext, "hwnd", $hOPENGL32RenderingContext )
	If @error Or Not $aRet[0] Then Return SetError(5,0,0)

	Return SetError(0,0,1)

EndFunc

Func DisableOpenGL( $hWnd, $hDeviceContext, $hOPENGL32RenderingContext )
	DllCall( $dllOpenGL32, "int", "wglMakeCurrent", "hwnd", 0, "hwnd", 0 )
	DllCall( $dllOpenGL32, "int", "wglDeleteContext", "hwnd", $hOPENGL32RenderingContext )
	DllCall( $dllUser32, "int", "ReleaseDC", "hwnd", $hWnd, "hwnd", $hDeviceContext )
EndFunc

Func glBegin($mode)
	DllCall($dllOpenGL32, "none", "glBegin", "uint", $mode)
EndFunc

Func glCallList($list)
	DllCall($dllOpenGL32, "none", "glCallList", "uint", $list)
EndFunc

Func glClear($mask)
	DllCall($dllOpenGL32, "none", "glClear", "uint", $mask)
EndFunc

Func glClearColor($red, $green, $blue, $alpha)
	DllCall($dllOpenGL32, "none", "glClearColor", "float", $red, "float", $green, "float", $blue, "float", $alpha)
EndFunc

Func glColor3f($red, $green, $blue)
	DllCall($dllOpenGL32, "none", "glColor3f", "float", $red, "float", $green, "float", $blue)
EndFunc

Func glColor3ub($red, $green, $blue)
	DllCall($dllOpenGL32, "none", "glColor3ub", "ubyte", $red, "ubyte", $green, "ubyte", $blue)
EndFunc

Func glDeleteLists($list, $range)
	DllCall($dllOpenGL32, "none", "glDeleteLists", "uint", $list, "int", $range)
EndFunc

Func glEnable($cap)
	DllCall($dllOpenGL32, "none", "glEnable", "uint", $cap)
EndFunc

Func glEnd()
	DllCall($dllOpenGL32, "none", "glEnd")
EndFunc

Func glEndList()
	DllCall($dllOpenGL32, "none", "glEndList")
EndFunc

Func glGenLists($range)
	Local $aRet = DllCall($dllOpenGL32, "uint", "glGenLists", "int", $range)
	Return $aRet[0] 
EndFunc

Func glGetFloatv( $pname, ByRef $params )
	Local $a = 0, $n = 1
	If IsArray( $params ) Then
		$a = 1
		$n = UBound( $params )
	EndIf
	Local $tFloat = DllStructCreate( "float[" & $n & "]" )
	Local $aRet = DllCall( $dllOpenGL32, "none", "glGetFloatv", "uint", $pname, "ptr", DllStructGetPtr( $tFloat ) )
	If @error Then Return SetError( 1, 0, 0 )
	If $a Then
		For $i = 0 To $n - 1
			$params[$i] = DllStructGetData( $tFloat, 1, $i+1 )
		Next
	Else
		$params = DllStructGetData( $tFloat, 1, 1 )
	EndIf
EndFunc

Func glGetIntegerv( $pname, ByRef $params )
	Local $a = 0, $n = 1
	If IsArray( $params ) Then
		$a = 1
		$n = UBound( $params )
	EndIf
	Local $tInt = DllStructCreate( "int[" & $n & "]" )
	Local $aRet = DllCall( $dllOpenGL32, "none", "glGetIntegerv", "uint", $pname, "ptr", DllStructGetPtr( $tInt ) )
	If @error Then Return SetError( 1, 0, 0 )
	If $a Then
		For $i = 0 To $n - 1
			$params[$i] = DllStructGetData( $tInt, 1, $i+1 )
		Next
	Else
		$params = DllStructGetData( $tInt, 1, 1 )
	EndIf
EndFunc

Func glLoadIdentity()
	DllCall($dllOpenGL32, "none", "glLoadIdentity")
EndFunc

Func glMatrixMode($mode)
	DllCall($dllOpenGL32, "none", "glMatrixMode", "uint", $mode)
EndFunc

Func glMultMatrixf( $m )
	Local $tFloat = DllStructCreate( "float[16]" )
	For $i = 0 To 15
		DllStructSetData( $tFloat, 1, $m[$i], $i+1 )
	Next
	DllCall( $dllOpenGL32, "none", "glMultMatrixf", "ptr", DllStructGetPtr( $tFloat ) )
EndFunc

Func glNewList($list, $mode)
	DllCall($dllOpenGL32, "none", "glNewList", "uint", $list, "uint", $mode)
EndFunc

Func glOrtho($left, $right, $bottom, $top, $zNear, $zFar)
	DllCall($dllOpenGL32, "none", "glOrtho", "double", $left, "double", $right, "double", $bottom, "double", $top, "double", $zNear, "double", $zFar)
EndFunc

Func glPopMatrix()
	DllCall($dllOpenGL32, "none", "glPopMatrix")
EndFunc

Func glPushMatrix()
	DllCall($dllOpenGL32, "none", "glPushMatrix")
EndFunc

Func glRotatef($angle, $x, $y, $z)
	DllCall($dllOpenGL32, "none", "glRotatef", "float", $angle, "float", $x, "float", $y, "float", $z)
EndFunc

Func glScalef($x, $y, $z)
	DllCall($dllOpenGL32, "none", "glScalef", "float", $x, "float", $y, "float", $z)
EndFunc

Func glShadeModel($mode)
	DllCall($dllOpenGL32, "none", "glShadeModel", "uint", $mode)
EndFunc

Func glTranslatef($x, $y, $z)
	DllCall($dllOpenGL32, "none", "glTranslatef", "float", $x, "float", $y, "float", $z)
EndFunc

Func glVertex3f($x, $y, $z)
	DllCall($dllOpenGL32, "none", "glVertex3f", "float", $x, "float", $y, "float", $z)
EndFunc

Func glViewport($x, $y, $width, $height)
	DllCall($dllOpenGL32, "none", "glViewport", "int", $x, "int", $y, "int", $width, "int", $height)
EndFunc

Func gluLookAt( $eyex, $eyey, $eyez, $centerx, $centery, $centerz, $upx, $upy, $upz )
	DllCall( $dllGLU32, "none", "gluLookAt", _
											"double", $eyex,    "double", $eyey,    "double", $eyez, _
											"double", $centerx, "double", $centery, "double", $centerz, _
											"double", $upx,     "double", $upy,     "double", $upz )
EndFunc

Func gluProject( $objx, $objy, $objz, ByRef $modelMatrix, ByRef $projMatrix, ByRef $viewport, ByRef $winx, ByRef $winy, ByRef $winz )
	Local $n
	$n = UBound( $modelMatrix )
	Local $tModelMatrix = DllStructCreate( "double[" & $n & "]" )
	For $i = 0 To $n - 1
		DllStructSetData( $tModelMatrix, 1, $modelMatrix[$i], $i+1 )
	Next
	$n = UBound( $projMatrix )
	Local $tProjMatrix = DllStructCreate( "double[" & $n & "]" )
	For $i = 0 To $n - 1
		DllStructSetData( $tProjMatrix, 1, $projMatrix[$i], $i+1 )
	Next
	$n = UBound( $viewport )
	Local $tViewport = DllStructCreate( "int[" & $n & "]" )
	For $i = 0 To $n - 1
		DllStructSetData( $tViewport, 1, $viewport[$i], $i+1 )
	Next
	Local $aRet = DllCall( $dllGLU32, "int", "gluProject", _
																		"double", $objx, "double", $objy, "double", $objz, _
																		"ptr", DllStructGetPtr( $tModelMatrix ), "ptr", DllStructGetPtr( $tProjMatrix ), "ptr", DllStructGetPtr( $tViewport ), _
																		"double*", 0, "double*", 0, "double*", 0 ) 
	If @error Then Return SetError( 1, 0, 0 )
	$winx = $aRet[7]
	$winy = $aRet[8]
	$winz = $aRet[9]
EndFunc

Func SwapBuffers($hDC)
	DllCall($dllGDI32, "int", "SwapBuffers", "hwnd", $hDC)
EndFunc
